Attribute VB_Name = "modTcContour"
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2001                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'

Option Explicit

Sub BuildTurboCADContourMap()
    On Error GoTo BuildError

    Dim tcapp As IMSIGX.Application
    Dim dwg As IMSIGX.Drawing
    Set tcapp = CreateObject("TurboCAD.Application")
    If tcapp Is Nothing Then
        MsgBox "Could not create TurboCAD application"
        Exit Sub
    End If
    
    'Create a new drawing
    Set dwg = tcapp.Drawings.Add
    
    Dim grs As IMSIGX.Graphics
    Dim gr As IMSIGX.Graphic

    'Target to add graphics to
    Set grs = dwg.Graphics
    
    Dim r As Long
    Dim coord As Long
    Dim id As Long
    Dim ncoords As Long
    Dim lastId As Long
    Dim x As Double
    Dim y As Double
    Dim z As Double
    
    'Format of worksheet
    'In each row:
    'Col 1:  id of contour line
    'Col 2:  starting coordinate index for this row
    'Col 3:  number of x-y coordinate pairs in this row
    'Col 4:  contour elevation (in feet)
    'Col 5, 7, etc.:  x coordinate (UTM, meters)
    'Col 6, 8, etc.:  y coordinate
    
    lastId = -1
    With ThisWorkbook.ActiveSheet.Cells
        For r = 1 To 10
        
            'If no id, we're done
            If .Item(r, 1) = "" Then
                Exit For
            End If
            
            id = .Item(r, 1)
            Debug.Print "id: " & id
            
            'New id: generate new polyline
            If id <> lastId Then
                Set gr = grs.Add
                lastId = id
            End If
            
            'Get number of coordinates and elevation
            ncoords = .Item(r, 3)
            z = .Item(r, 4)
            
            For coord = 1 To ncoords
            
                'Get x-y coordinates and create polyline vertex
                x = .Item(r, 2 * coord + 3)
                y = .Item(r, 2 * coord + 4)
                gr.Vertices.Add x, y, z
            Next
        Next
    End With
    
    dwg.SaveAs "TestDwg.tcw"
    
Cleanup:
    'Release TurboCAD stuff
    Set gr = Nothing
    Set grs = Nothing
    Set dwg = Nothing
    tcapp.Quit
    Set tcapp = Nothing

    Exit Sub
    
BuildError:
    MsgBox "Error " & Err.Description
    GoTo Cleanup

End Sub
