VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Length"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'/******************************************************************/
'/*                                                                */
'/*                      TurboCAD for Windows                      */
'/*                   Copyright (c) 1993 - 2001                    */
'/*             International Microcomputer Software, Inc.         */
'/*                            (IMSI)                              */
'/*                      All rights reserved.                      */
'/*                                                                */
'/******************************************************************/

'DBAPI constants
Const gkGraphic = 11
Const gkArc = 2
Const gkText = 6
Const gfCosmetic = 128&

'Useful math constants
Const pi# = 3.14159265

'Real variant types!
Const typeEmpty = 0
Const typeInteger = 2
Const typeLong = 3
Const typeSingle = 4
Const typeDouble = 5
Const typeCurrency = 6
Const typeDate = 7
Const typeString = 8
Const typeObject = 9
Const typeBoolean = 11
Const typeVariant = 12
Const typeIntegerEnum = typeInteger + 100
Const typeLongEnum = typeLong + 100
Const typeStringEnum = typeString + 100

'Stock property pages
Const ppStockPen = 1
Const ppStockBrush = 2
Const ppStockText = 4
Const ppStockInsert = 8
Const ppStockViewport = 16
Const ppStockAuto = 32

'Property Ids
Const idLength = 1

'Property enums

'Number of properties, pages, wizards
Const NUM_PROPERTIES = 1
Const NUM_PAGES = 1
Const NUM_WIZARDS = 0
Const formCaption = "Cable"

Private Sub Class_Initialize()
    'Initialize class variables
End Sub

'Returns the user-visible description of this RegenMethod
Public Property Get Description() As String
    Description = "SDK Cable"
End Property

'Returns the persistent class id for this RegenMethod's property section
Public Property Get ClassID() As String
    ClassID = "{50F5B6D0-9628-11d1-A40A-0000B465872B}"
End Property

'Retrieve types and names
Public Function GetPropertyInfo(Names As Variant, Types As Variant, _
    IDs As Variant, Defaults As Variant) As Long
    ReDim Names(NUM_PROPERTIES), Types(NUM_PROPERTIES), _
        IDs(NUM_PROPERTIES), Defaults(NUM_PROPERTIES)
    Names(0) = "Length"
    Types(0) = typeDouble
    IDs(0) = idLength
    Defaults(0) = S
    GetPropertyInfo = NUM_PROPERTIES
End Function

'Get the number of property pages supporting this RegenMethod
Public Function GetPageInfo(ByVal AGraphic As Object, StockPages As Long, _
    Names As Variant) As Long
    ReDim Names(NUM_PAGES)

    'Need the form
    'Load frmCable
    'Names(0) = frmCable.Caption
    'Unload frmCable
    Names(0) = formCaption
    StockPages = ppStockBrush + ppStockPen + ppStockAuto
    GetPageInfo = NUM_PAGES
End Function

Public Function GetWizardInfo(Names As Variant) As Long
    ReDim Names(NUM_WIZARDS)
    GetWizardInfo = NUM_WIZARDS
End Function

'Enumerate the names and values of a specified property
Public Function GetEnumNames(ByVal PropID As Long, Names As Variant, Values As Variant) As Long
    GetEnumNames = 0
End Function

Public Function PageControls(ByVal ThisRegenMethod As Object, ByVal Graphic As Object, ByVal PageNumber As Long, ByVal SaveProperties As Boolean) As Boolean
        'Set up error function
        On Error GoTo Failed

        Dim Length#
        If SaveProperties Then
            'OK button on property page was clicked
            'Form is still loaded
            With frmCable
                'Need On Error statement for the case where you have
                'Length Turbo Shape and ahother "shape" selected
                On Error Resume Next

                'When the property page is closed, transfer the numeric
                'Length value from the TextBox to the Graphic
                'Get the value as a double-precision number
                Length# = CDbl(.txtLength.Text)
                'Make sure it's between 0 and 100
                If Length# < 0# Then Length# = 0#
                'Set the Length property value in the Graphic
                Graphic.Properties("Length") = Length#
            End With
        Else
            'Property page is about to be opened
            'Make sure the form is loaded
            Load frmCable
            With frmCable
                'If more than one Length is selected and they do not
                'have the same properties, don't set up this field
                On Error GoTo NoRType

                'When the property page is opening, transfer the numeric
                ' Length value from the Graphic to the TextBox
                'Get the Length property value from the Graphic
                Length# = Graphic.Properties("Length")
                'Set the TextBox control's text
                .txtLength.Text = Length#
NoRType:
            End With
        End If
        S = Length
        PageControls = True
        Exit Function

Failed:
        'For debugging purposes, report that an error occurred
        If Err.Number <> 0 Then
            MsgBox "Error in PageControls: " & Err.Description
        End If

        'Return false if an error occurred
        PageControls = False
End Function

Public Function PageDone(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant)
        'Done with form
        Unload frmCable
End Function

Public Function PropertyPages(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant) As Boolean
    With frmCable
        .Show vbModal
        PropertyPages = Not .DialogCanceled
    End With
End Function

Public Function Wizard(ByVal ThisRegenMethod As Object, Optional WizardNumber As Variant) As Boolean
    Wizard = False
End Function

'Called when vertex has been moved, or other geometry change
Public Function OnGeometryChanged(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant)
    'Do nothing
    'Regen Graphic
End Function

'Called when vertex is moved, or other geometry change
Public Function OnGeometryChanging(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant) As Boolean
    'OK to continue with change
    OnGeometryChanging = True
End Function

Public Function OnNewGraphic(ByVal grfThis As Object, ByVal boolCopy As Boolean) As Boolean
    If boolCopy Then
        'Vertices are already added for us...
        OnNewGraphic = True
        Exit Function
    End If
    xx0 = 4#
    yy0 = 5#
    zz0 = 0#
    xx1 = 8#
    yy1 = 8#
    dxx = 4#
    dyy = 4#
    S = 8#
    On Error GoTo Failed
    'New Graphic being created
    'X, Y, Z, PenDown, Selectable, Snappable, Editable, Linkable
    'First Vertex is "left" point
    grfThis.Vertices.Add xx0, yy0, 0#, False, True, True, True, True
    'Second Vertex is "right" point
    grfThis.Vertices.Add xx1, yy1, 0#, False, True, True, True, True
        
    grfThis.Properties("LimitVertices") = 2
    OnNewGraphic = True
    Exit Function

Failed:
    'Return false on failure
    OnNewGraphic = False
End Function

'Function called whenever a copy of a graphic is being made
Public Function OnCopyGraphic(ByVal grfCopy As Object, ByVal grfSource As Object) As Boolean
    'Return false on failure
    OnCopyGraphic = True
End Function

'Notification function called after graphic property is saved
Public Function OnPropertyChanged(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant)
    'Do nothing
End Function

'Notification function called when graphic property is saved
Public Function OnPropertyChanging(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant) As Boolean
    'OK to proceed
    OnPropertyChanging = True
End Function

'Notification function called when graphic property is retrieved
Public Function OnPropertyGet(ByVal Graphic As Object, ByVal PropID As Long)
    'Do nothing
End Function

'Called when we need to update our object
Public Function Regen(ByVal grfThis As Object)
        'Setup error handler
        On Error GoTo Failed

        'Set up lock (prevent recursion)
        Dim LockCount&
        LockCount& = grfThis.RegenLock

        'Setup error handler (make sure lock is removed)
        On Error GoTo FailedLock
        If LockCount& = 0 Then
            'Delete any previous cosmetic children
            grfThis.Graphics.Clear gfCosmetic

            Dim boolHandleMoved As Boolean
    
            Dim W#, H#, R#, Length#

            'Add child Graphics
            Dim grfChild As Object
            Dim x#, y#, z#, xz#
            With grfThis.Vertices
                xx0 = .Item(0).x
                yy0 = .Item(0).y
                zz0 = .Item(0).z
                
                xx1 = .Item(1).x
                yy1 = .Item(1).y
                zz1 = .Item(0).z
            End With
            
            dxx = xx1 - xx0
            dyy = yy1 - yy0
            dzz = zz1 - zz0
            dxz = Sqr(dxx * dxx + dzz * dzz)
            Dim Sina#, Cosa#
            Sina = dzz / dxz
            Cosa = dxx / dxz
            
            If S * S < (dxx * dxx + dyy * dyy + dzz * dzz) Then
                S = 1.001 * Sqr(dxx * dxx + dyy * dyy + dzz * dzz)
                grfThis.Properties("Length") = Format(S, "###0.00")
                frmCable.txtLength.Text = Format(S, "###0.00")
                Length = S
            End If
            a = Nonline_equ(1#)
            Dim e#
            e = Exp(dxz / a)
            z = dyy / a / (e - 1) + Sqr(Square(dyy / a / (e - 1#)) - (1# / e - 1#) / (e - 1#))
            xzn = a * Log(z)
            e = Exp(xzn / a)
            yyn = a / 2# * (e + 1# / e) - a
            xzk = xzn + dxz
            e = Exp(xzk / a)
            yyk = a / 2# * (e + 1# / e) - a
            Dim xa(11) As Variant, ya(11) As Variant, za(11) As Variant
            Dim i As Long, i1 As Long
            i = 0
            
            For xz = xzn To xzk + 0.01 * dxz Step dxz / 10#
                e = Exp(xz / a)
                y = a / 2# * (e + 1# / e) - a
                xa(i) = xz * Cosa + (xx0 - xzn * Cosa)
                ya(i) = y + (yy0 - yyn)
                za(i) = xz * Sina * Sign(dzz) + (zz0 - xzn * Sina + Sign(dzz))
                i = i + 1
            Next xz
 Set grfChild = grfThis.Graphics.AddCurveBezier(xa(0), ya(0), za(0))
                grfChild.Cosmetic = True
 Dim Ver As Object
 
 For i = 1 To 10
   Set Ver = grfChild.Vertices.Add(xa(i), ya(i), za(i))
 Next i
 
 i = 0
  Set grfChild = grfThis.Graphics.AddCircleCenterAndPoint(xa(i), ya(i), za(i), xa(i), ya(i) + 0.05, za(i))
                grfChild.Cosmetic = True
 i = 10
  Set grfChild = grfThis.Graphics.AddCircleCenterAndPoint(xa(i), ya(i), za(i), xa(i), ya(i) + 0.05, za(i))
                grfChild.Cosmetic = True
  i = 3
  Set grfChild = grfThis.Graphics.AddLineSingle(xa(i), ya(i), za(i), xa(i), ya(i) - 0.5, za(i))
                grfChild.Cosmetic = True
  Set grfChild = grfThis.Graphics.Add(, "TCW40SPHERE")
                grfChild.Properties("Solid") = 0
                grfChild.Cosmetic = True
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.8, za(i))
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.5, za(i))
        
 i = 5
  Set grfChild = grfThis.Graphics.AddLineSingle(xa(i), ya(i), za(i), xa(i), ya(i) - 0.5, za(i))
                grfChild.Cosmetic = True
  Set grfChild = grfThis.Graphics.Add(, "TCW40SPHERE")
                grfChild.Properties("Solid") = 0
                grfChild.Cosmetic = True
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.8, za(i))
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.5, za(i))
 i = 7
  Set grfChild = grfThis.Graphics.AddLineSingle(xa(i), ya(i), za(i), xa(i), ya(i) - 0.5, za(i))
                grfChild.Cosmetic = True
  Set grfChild = grfThis.Graphics.Add(, "TCW40SPHERE")
                grfChild.Properties("Solid") = 0
                grfChild.Cosmetic = True
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.8, za(i))
  Set Ver = grfChild.Vertices.Add(xa(i), ya(i) - 0.5, za(i))
  
                               
            'Add visible child Graphics
        End If

        grfThis.RegenUnlock
        Exit Function

FailedLock:
        'Remove lock
        grfThis.RegenUnlock

Failed:
End Function

Public Function Draw(ByVal grfThis As Object, ByVal view As Object, Optional mat As Variant) As Boolean
    'Return True if we did the redraw (no further processing necessary, no children will be drawn).
    'Since this is just a test, we return False to let TurboCAD do the drawing operation.
    Draw = False
End Function
Public Function Nonline_equ(y#) As Double

    Dim y1#, y2#, y12#, f1#, f2#, f12#, dy#
    dy = 0.11
    Dim pr%
    
    y1 = y
    f1 = func(y1)
    y2 = y1 + dy
    f2 = func(y2)
    
    If f2 > f1 Then
        pr = 1
    Else
        pr = 2
    End If
    
    If pr = 1 Then
        If f1 > 0# Then
            y2 = y1 - dy
            f2 = func(y2)
L1:
            If f2 > 0# Then
                y2 = y2 - dy
                f2 = func(y2)
                GoTo L1
            End If
        Else
L2:
            If f2 < 0 Then
                y2 = y2 + dy
                f2 = func(y2)
                GoTo L2
            End If
        End If
    Else
        If f1 < 0# Then
            y2 = y1 - dy
            f2 = func(y2)
L3:
            If f2 < 0 Then
                y2 = y2 - dy
                f2 = func(y2)
                GoTo L3
            End If
        Else
L4:
            If f2 > 0 Then
                y2 = y2 + dy
                f2 = func(y2)
                GoTo L4
            End If
        End If
    End If
    
L5:
    y12 = (y1 + y2) / 2#
    f12 = func(y12)
    If Absr(y1 - y2) > 0.000001 Then
        If Sign(f12) = Sign(f1) Then
            y1 = y12
            GoTo L5
        Else
            y2 = y12
            GoTo L5
        End If
    End If
    Nonline_equ = y12
                           
End Function


Public Function Square(y As Double) As Double

    Square = y * y

End Function


Public Function func(y As Double) As Double
    Dim f#, z#, e#
    e = Exp(dxz / y)
    z = dyy / y / (e - 1#) + Sqr(Square(dyy / y / (e - 1#)) - (1# / e - 1#) / (e - 1#))
    func = y / 2# * (z * (e - 1#) - 1# / z * (1# / e - 1#)) - S
    
End Function


Public Function Sign(y As Double) As Double
    
    If y > 0# Then
        Sign = 1#
    End If
    If y < 0# Then
        Sign = -1#
    End If
    If y = 0# Then
        Sign = 0#
    End If
    
End Function


Public Function Absr(y As Double) As Double

    If y > 0# Then
        Absr = y
    Else
        Absr = -y
    End If
    
End Function
