VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Detail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'/******************************************************************/
'/*                                                                */
'/*                      TurboCAD for Windows                      */
'/*                   Copyright (c) 1993 - 2001                    */
'/*             International Microcomputer Software, Inc.         */
'/*                            (IMSI)                              */
'/*                      All rights reserved.                      */
'/*                                                                */
'/******************************************************************/

'DBAPI constants
Const gkGraphic = 11
Const gkArc = 2
Const gkText = 6
Const gfCosmetic = 128&
                                                                                                                                                                                             
'Useful math constants
Const Pi# = 3.14159265

'Real variant types!
Const typeEmpty = 0
Const typeInteger = 2
Const typeLong = 3
Const typeSingle = 4
Const typeDouble = 5
Const typeCurrency = 6
Const typeDate = 7
Const typeString = 8
Const typeObject = 9
Const typeBoolean = 11
Const typeVariant = 12
Const typeIntegerEnum = typeInteger + 100
Const typeLongEnum = typeLong + 100
Const typeStringEnum = typeString + 100

'Stock property pages
Const ppStockPen = 1
Const ppStockBrush = 2
Const ppStockText = 4
Const ppStockInsert = 8
Const ppStockViewport = 16
Const ppStockAuto = 32

'Property Ids
Const idDiameter = 1
Const idLength = 2
Const idBType = 3
Const idScrewView = 4

Const idLengthOld = 5
Const idLengthThread = 6

Const idDiameterOld = 7
Const idBTypeOld = 8
Const idScrewViewOld = 9
Const idLengthThreadOld = 10

Const idX0Old = 11
Const idY0Old = 12
Const idX1Old = 13
Const idY1Old = 14
Const idX2Old = 15
Const idY2Old = 16


'Property enums
Const NUM_TYPES = 0


'Number of properties, pages, wizards
Const NUM_PROPERTIES = 16
Const NUM_PAGES = 1
Const NUM_WIZARDS = 0

Private PColor As Long
Private BColor As Long


Private Sub Class_Initialize()
    'Initialize class variables
End Sub

'Returns the user-visible description of this RegenMethod
Public Property Get Description() As String
    Description = "SDK Fasteners"
End Property

'Returns the persistent class id for this RegenMethod's property section
Public Property Get ClassID() As String
    ClassID = "{FDB6F1C3-9631-11d1-A40A-0000B465872B}"
End Property

'Retrieve types and names
Public Function GetPropertyInfo(Names As Variant, Types As Variant, _
    IDs As Variant, Defaults As Variant) As Long
    ReDim Names(NUM_PROPERTIES), Types(NUM_PROPERTIES), _
        IDs(NUM_PROPERTIES), Defaults(NUM_PROPERTIES)
        
    Names(0) = "DiameterB"
    Types(0) = typeDouble
    IDs(0) = idDiameter
    Defaults(0) = 1#

    Names(1) = "LengthB"
    Types(1) = typeDouble
    IDs(1) = idLength
    Defaults(1) = 3#
    
    Names(2) = "BType"
    Types(2) = typeString
    IDs(2) = idBType
    Defaults(2) = "HexBolt"
    
    Names(3) = "ScrewView"
    Types(3) = typeString
    IDs(3) = idScrewView
    Defaults(3) = "FrontSection"
    
    Names(4) = "LengthOldB"
    Types(4) = typeDouble
    IDs(4) = idLengthOld
    Defaults(4) = 3#
   
    Names(5) = "LengthThreadB"
    Types(5) = typeDouble
    IDs(5) = idLengthThread
    Defaults(5) = 1.5
   
    Names(6) = "DiameterOldB"
    Types(6) = typeDouble
    IDs(6) = idDiameterOld
    Defaults(6) = 1#
    
    Names(7) = "BTypeOld"
    Types(7) = typeString
    IDs(7) = idBTypeOld
    Defaults(7) = "HexBolt"
    
    Names(8) = "ScrewViewOld"
    Types(8) = typeString
    IDs(8) = idScrewViewOld
    Defaults(8) = "FrontSection"
    
    Names(9) = "LengthThreadOldB"
    Types(9) = typeDouble
    IDs(9) = idLengthThreadOld
    Defaults(9) = 1.5
    
    Names(10) = "X0OldB"
    Types(10) = typeDouble
    IDs(10) = idX0Old
    Defaults(10) = 0#
   
    Names(11) = "Y0OldB"
    Types(11) = typeDouble
    IDs(11) = idY0Old
    Defaults(11) = 0#
   
    Names(12) = "X1OldB"
    Types(12) = typeDouble
    IDs(12) = idX1Old
    Defaults(12) = 3#
   
    Names(13) = "Y1OldB"
    Types(13) = typeDouble
    IDs(13) = idY1Old
    Defaults(13) = 0#
   
    Names(14) = "X2OldB"
    Types(14) = typeDouble
    IDs(14) = idX2Old
    Defaults(14) = 1.5
   
    Names(15) = "Y2OldB"
    Types(15) = typeDouble
    IDs(15) = idY2Old
    Defaults(15) = 0#
    
   GetPropertyInfo = NUM_PROPERTIES
End Function

'Get the number of property pages supporting this RegenMethod
Public Function GetPageInfo(ByVal AGraphic As Object, StockPages As Long, _
    Names As Variant) As Long
    ReDim Names(NUM_PAGES)

    'Need the form
'    Load frmFasteners
'    Names(0) = frmFasteners.Caption
'    Unload frmFasteners
    Names(0) = LoadResString(101)
    StockPages = ppStockBrush + ppStockPen + ppStockAuto
    GetPageInfo = NUM_PAGES
End Function

Public Function GetWizardInfo(Names As Variant) As Long
    ReDim Names(NUM_WIZARDS)
    GetWizardInfo = NUM_WIZARDS
End Function

'Enumerate the names and values of a specified property
Public Function GetEnumNames(ByVal PropID As Long, Names As Variant, Values As Variant) As Long
        GetEnumNames = 0
End Function

Public Function PageControls(ByVal ThisRegenMethod As Object, ByVal Graphic As Object, ByVal PageNumber As Long, ByVal SaveProperties As Boolean) As Boolean
        'Set up error function
        On Error GoTo Failed
        Dim Diameter#, Length#, LengthThread#
        If SaveProperties Then
            'OK button on property page was clicked
            'Form is still loaded
            With frmFasteners
                'Need On Error statement for the case where you have
                'RRect Turbo Shape and ahother "shape" selected
                On Error Resume Next
                'When the property page is closed, transfer the numeric
                'Diameter value from the TextBox to the Graphic
                'Get the value as a double-precision number
                Diameter# = CDbl(.txtdd.Text)
                Length# = CDbl(.txtLen.Text)
                LengthThread# = CDbl(.txtThread.Text)
                TypeB = .List1.Text
                ViewB = .List2.Text
                'Make sure it's between 0 and 100
                If Diameter# < 0# Then Diameter# = 1#
                If Diameter# > 3# Then Diameter# = 3#
                If LengthThread > Length Then LengthThread = Length
                'Set the roundness property value in the Graphic
                Graphic.Properties("DiameterB") = Diameter#
                Graphic.Properties("LengthB") = Length#
                Graphic.Properties("LengthThreadB") = LengthThread#
                Graphic.Properties("BType") = TypeB
                Graphic.Properties("ScrewView") = ViewB
            End With
        Else
            'Property page is about to be opened
            'Make sure the form is loaded
                Diameter# = Graphic.Properties("DiameterB")
                Length# = Graphic.Properties("LengthB")
                LengthThread = Graphic.Properties("LengthThreadB")
                TypeB = Graphic.Properties("BType")
                ViewB = Graphic.Properties("ScrewView")
            Load frmFasteners
            With frmFasteners
            
                'If more than one RRect is selected and they do not
                'have the same properties, don't set up this field
                On Error GoTo NoRType

                'When the property page is opening, transfer the numeric
                'roundness value from the Graphic to the TextBox
                'Get the roundness property value from the Graphic
                'Set the TextBox control's text
                .txtdd.Text = Diameter#
                .txtLen = Length#
                .txtThread.Text = LengthThread#
NoRType:
            End With
        End If

        PageControls = True
        Exit Function

Failed:
        'For debugging purposes, report that an error occurred
        If Err.Number <> 0 Then
            MsgBox "Error in PageControls: " & Err.Description
        End If

        'Return false if an error occurred
        PageControls = False
End Function

Public Function PageDone(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant)
        'Done with form
        Unload frmFasteners
End Function

Public Function PropertyPages(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant) As Boolean
    With frmFasteners
        .Show vbModal
        PropertyPages = Not .DialogCanceled
    End With
End Function

Public Function Wizard(ByVal ThisRegenMethod As Object, Optional WizardNumber As Variant) As Boolean
    Wizard = False
End Function

'Called when vertex has been moved, or other geometry change
Public Function OnGeometryChanged(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant)
    'Do nothing
    'Regen Graphic
End Function

'Called when vertex is moved, or other geometry change
Public Function OnGeometryChanging(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant) As Boolean
    'OK to continue with change
    OnGeometryChanging = True
End Function

Public Function OnNewGraphic(ByVal grfThis1 As Object, ByVal boolCopy As Boolean) As Boolean
    If boolCopy Then
        'Vertices are already added for us...
        OnNewGraphic = True
        Exit Function
    End If
Dim grfThis As Graphic
    Set grfThis = grfThis1
    On Error GoTo Failed
    'New Graphic being created
    'X, Y, Z, PenDown, Selectable, Snappable, Editable, Linkable
    'First Vertex is "first point of axis"
    grfThis.Vertices.Add 0#, 0, 0#, False, True, True, True, True, False
    
    'Second Vertex is "Second point of axis"
    grfThis.Vertices.Add 3#, 0, 0#, False, True, True, True, True, False
    
    'Third Vertex is "Point on theard"
    grfThis.Vertices.Add 1.5, 0, 0#, False, True, True, True, True, False
    
    grfThis.Properties("PenColor") = RGB(0, 0, 0)
    grfThis.Properties("BrushColor") = RGB(255, 255, 255)
    
    
    OnNewGraphic = True
    Exit Function

Failed:
    'Return false on failure
    OnNewGraphic = False
End Function

'Function called whenever a copy of a graphic is being made
Public Function OnCopyGraphic(ByVal grfCopy As Object, ByVal grfSource As Object) As Boolean
    'Return false on failure
    OnCopyGraphic = True
End Function

'Notification function called after graphic property is saved
Public Function OnPropertyChanged(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant)
    'Do nothing
End Function

'Notification function called when graphic property is saved
Public Function OnPropertyChanging(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant) As Boolean
    'OK to proceed
    OnPropertyChanging = True
End Function

'Notification function called when graphic property is retrieved
Public Function OnPropertyGet(ByVal Graphic As Object, ByVal PropID As Long)
    'Do nothing
End Function

'Called when we need to update our object
Public Function Regen(ByVal grfThis1 As Object)
        'Setup error handler
        On Error GoTo Failed
Dim grfThis As Graphic
        Set grfThis = grfThis1
        PColor = grfThis.Properties("PenColor")
''AALB problem with load old files
' AALB try to fix bug with reading files from TC v6.5 (problem is that some sdk regens
' has Type = 7(Group, must be GRAPHIc (11))
On Error Resume Next
Err.Clear
        BColor = grfThis.Properties("BrushColor")
        If Err.Number <> 0 Then
            BColor = RGB(255, 255, 255)
            Err.Clear
        End If
        
        
        
        'Set up lock (prevent recursion)
Dim LockCount&
        LockCount& = grfThis.RegenLock

        'Setup error handler (make sure lock is removed)
        On Error GoTo FailedLock
        If LockCount& = 0 Then
            'Delete any previous cosmetic children
            grfThis.Graphics.Clear gfCosmetic

Dim dd#, ddOld#
Dim TypeBOld As String, ViewBOld As String
                dd = grfThis.Properties("DiameterB")
                ddOld = grfThis.Properties("DiameterOldB")
                
                TypeB = grfThis.Properties("BType")
                TypeBOld = grfThis.Properties("BTypeOld")
                
                ViewB = grfThis.Properties("ScrewView")
                ViewBOld = grfThis.Properties("ScrewViewOld")
Dim x0Old#, y0Old#, x1Old#, y1Old#, x2Old#, y2Old#
                x0Old = grfThis.Properties("x0OldB")
                y0Old = grfThis.Properties("y0OldB")
                x1Old = grfThis.Properties("x1OldB")
                y1Old = grfThis.Properties("y1OldB")
                x2Old = grfThis.Properties("x2OldB")
                y2Old = grfThis.Properties("y2OldB")
                
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Dim Salp#, Calp#, L#
Dim X00#, Y00#, X01#, Y01#, X02#, Y02#
Dim LenProp#, LenOld#
        LenProp = grfThis.Properties("LengthB")
        LenOld = grfThis.Properties("LengthOldB")
Dim LenPropThread#, LenThreadOld#
Dim LThread#
        LenPropThread = grfThis.Properties("LengthThreadB")
        LThread = LenPropThread
        LenThreadOld = grfThis.Properties("LengthThreadOldB")

        With grfThis.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
            X02 = .Item(2).X
            Y02 = .Item(2).Y
            L = Sqr((X01 - X00) * (X01 - X00) + (Y01 - Y00) * (Y01 - Y00))
            If Abs(L) < 0.001 Then
                X00 = x0Old
                Y00 = y0Old
                X01 = x1Old
                Y01 = y1Old
                X02 = x2Old
                Y02 = y2Old
                L = Sqr((X01 - X00) * (X01 - X00) + (Y01 - Y00) * (Y01 - Y00))
                .Item(0).X = X00
                .Item(0).Y = Y00
                .Item(1).X = X01
                .Item(1).Y = Y01
                .Item(2).X = X02
                .Item(2).Y = Y02
            End If
            Salp = (Y01 - Y00) / L
            Calp = (X01 - X00) / L
        End With
'Dim ChangedUnits As Boolean
'        ChangedUnits = False
'        If Abs(L / 25.4 - LenProp) < 0.001 And Abs(LenProp - LenOld) < 0.001 Then
'            LenProp = L
'            LenOld = L
'            grfThis.Properties("LengthB") = L
'
'            dd = dd * 25.4
'            ddOld = dd
'            grfThis.Properties("DiameterB") = dd
'            LenPropThread = LenPropThread * 25.4
'            LenThreadOld = LenPropThread
'            LThread = LenPropThread
'            grfThis.Properties("LengthThreadB") = LenPropThread
'            ChangedUnits = True
'            GoTo LL
'        End If
        
        
' If there are changes in Property's Page
        If Abs(dd - ddOld) > 0.001 Or Abs(LenProp - LenOld) > 0.001 Or Abs(LenPropThread - LenThreadOld) > 0.001 Or TypeB <> TypeBOld Or ViewB <> ViewBOld Then
            If ViewB = "FrontSection" And (ViewBOld = "Front" Or ViewBOld = "Top") Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = Salp2
                Salp = -Calp2
                X01 = X00 + LenProp * Calp
                Y01 = Y00 + LenProp * Salp
                With grfThis.Vertices
                    .Item(1).X = X01
                    .Item(1).Y = Y01
                    L = LenProp
                End With
                X02 = X01 + (X00 - X01) * LenPropThread / LenProp
                Y02 = Y01 + (Y00 - Y01) * LenPropThread / LenProp
                With grfThis.Vertices
                    .Item(2).X = X02
                    .Item(2).Y = Y02
                End With
            End If
            If Abs(LenProp - LenOld) > 0.001 And ViewB = ViewBOld Then
                X01 = X00 + LenProp * Calp
                Y01 = Y00 + LenProp * Salp
                With grfThis.Vertices
                    .Item(1).X = X01
                    .Item(1).Y = Y01
                    L = LenProp
                End With
                If LenPropThread > LenProp Then
                    grfThis.Properties("LengthThreadB") = CDbl(Format(LenProp, "###0.00"))
                    LenPropThread = LenProp
                    LThread = LenPropThread
                End If
                X02 = X01 + (X00 - X01) * LenPropThread / LenProp
                Y02 = Y01 + (Y00 - Y01) * LenPropThread / LenProp
                With grfThis.Vertices
                    .Item(2).X = X02
                    .Item(2).Y = Y02
                End With
               
            End If
            If Abs(LenPropThread - LenThreadOld) > 0.001 And ViewB = ViewBOld Then
                If LenPropThread > LenProp Then
                    grfThis.Properties("LengthThreadB") = CDbl(Format(LenProp, "###0.00"))
                    LenPropThread = LenProp
                    LThread = LenPropThread
                End If
                X02 = X01 + (X00 - X01) * LenPropThread / LenProp
                Y02 = Y01 + (Y00 - Y01) * LenPropThread / LenProp
                With grfThis.Vertices
                    .Item(2).X = X02
                    .Item(2).Y = Y02
                End With
            End If
            GoTo LL
        End If
        
' If change location of the at least one base vertex
        If Abs(X00 - x0Old) > 0.001 Or Abs(Y00 - y0Old) > 0.001 Or Abs(X01 - x1Old) > 0.001 Or Abs(Y01 - y1Old) > 0.001 Or Abs(X02 - x2Old) > 0.001 Or Abs(Y02 - y2Old) > 0.001 Then
            If ViewB = "Front" Or ViewB = "Top" Then GoTo LL
            If Abs(X00 - x0Old) > 0.001 Or Abs(Y00 - y0Old) > 0.001 Or Abs(X01 - x1Old) > 0.001 Or Abs(Y01 - y1Old) > 0.001 Then
                grfThis.Properties("LengthB") = CDbl(Format(L, "###0.00"))
                If LThread > L Then
                    LThread = L
                    grfThis.Properties("LengthThreadB") = CDbl(Format(LThread, "###0.00"))
                End If
                X02 = X01 + (X00 - X01) * LThread / L
                Y02 = Y01 + (Y00 - Y01) * LThread / L
                With grfThis.Vertices
                    .Item(2).X = X02
                    .Item(2).Y = Y02
                End With
            End If
            If Abs(X00 - x0Old) < 0.001 And Abs(Y00 - y0Old) < 0.001 And Abs(X01 - x1Old) < 0.001 And Abs(Y01 - y1Old) < 0.001 Then
                If Abs(X02 - x2Old) > 0.001 Or Abs(Y02 - y2Old) > 0.001 Then
 Dim Salp1#, Calp1#
                    Salp1 = (Y00 - Y01) / L
                    Calp1 = (X00 - X01) / L
                    LThread = (Y02 - Y01) * Salp1 + (X02 - X01) * Calp1
                    If LThread > L Then LThread = L
                    If LThread < 0 Then LThread = 0#
                    grfThis.Properties("LengthThreadB") = CDbl(Format(LThread, "###0.00"))
                    X02 = X01 + (X00 - X01) * LThread / L
                    Y02 = Y01 + (Y00 - Y01) * LThread / L
                    With grfThis.Vertices
                        .Item(2).X = X02
                        .Item(2).Y = Y02
                    End With
                End If
            End If
        End If
LL:
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            If TypeB = "HexBolt" Then Call HexBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "SlottedBolt" Then Call SlottedBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "RHBolt" Then Call RHBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "THeadBolt" Then Call THeadBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "SquareBolt" Then Call SquareBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "RHSNBolt" Then Call RHSNBolt(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "HexFlScrew" Then Call HexFlScrew(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "SPHScrew" Then Call SPHScrew(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "SOCHScrew" Then Call SOCHScrew(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "SFHCScrew" Then Call SFHCScrew(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            If TypeB = "RHCScrew" Then Call RHCScrew(grfThis, dd, L, Salp, Calp, ViewB, ViewBOld, LThread)
            'Add visible child Graphics
        End If
        grfThis.Properties("DiameterOldB") = grfThis.Properties("DiameterB")
        grfThis.Properties("LengthOldB") = grfThis.Properties("LengthB")
        grfThis.Properties("LengthThreadOldB") = grfThis.Properties("LengthThreadB")
        grfThis.Properties("BTypeOld") = TypeB
        grfThis.Properties("ScrewViewOld") = ViewB
        grfThis.Properties("x0OldB") = X00
        grfThis.Properties("y0OldB") = Y00
        grfThis.Properties("x1OldB") = X01
        grfThis.Properties("y1OldB") = Y01
        grfThis.Properties("x2OldB") = X02
        grfThis.Properties("y2OldB") = Y02

        
        grfThis.RegenUnlock
        Exit Function

FailedLock:
        'Remove lock
        grfThis.RegenUnlock

Failed:
End Function

Public Function Draw(ByVal grfThis As Object, ByVal view As Object, Optional mat As Variant) As Boolean
    'Return True if we did the redraw (no further processing necessary, no children will be drawn).
    'Since this is just a test, we return False to let TurboCAD do the drawing operation.
    
    Draw = False
End Function
Private Function Angle(sinb As Double, cosb As Double) As Double

        If Abs(cosb) < 0.0001 Then
            If sinb > 0 Then
                Angle = Pi / 2
            Else
                Angle = 3 * Pi / 2
            End If
        Else
            If sinb >= 0 And cosb > 0 Then Angle = Atn(sinb / cosb)
            If sinb >= 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb > 0 Then Angle = 2 * Pi + Atn(sinb / cosb)
        End If
End Function

Private Sub SlottedBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
Dim D#, H#, T#, J#, del#, E#, F#
        D = 1.875 * dd
        H = 0.494 * dd
        T = 0.24 * dd
        J = 0.19 * dd
        del = 0.1 * dd
        
Dim X0(16)
Dim Y0(16)
Dim X(16)
Dim Y(16)
       
        X0(1) = H
        Y0(1) = dd / 2#
          
        X0(2) = X0(1)
        Y0(2) = -Y0(1)
          
        X0(3) = L - del
        Y0(3) = dd / 2#
          
        X0(4) = X0(3)
        Y0(4) = -Y0(3)
          
        X0(5) = L
        Y0(5) = dd / 2# - del
          
        X0(6) = X0(5)
        Y0(6) = -Y0(5)
          
        X0(7) = 0
        Y0(7) = D / 2#
          
        X0(8) = X0(7)
        Y0(8) = -Y0(7)
          
        X0(9) = 0
        Y0(9) = J / 2#
          
        X0(10) = X0(9)
        Y0(10) = -Y0(9)
          
        X0(11) = T
        Y0(11) = Y0(9)
          
        X0(12) = X0(11)
        Y0(12) = -Y0(11)
    '-------------------------------
        If LThread > 0 Then
            X0(13) = X0(5) - LThread
        Else
            X0(13) = X0(5) - del
        End If
        Y0(13) = dd / 2#
    
        X0(14) = X0(13)
        Y0(14) = -Y0(13)
          
        X0(15) = X0(13)
        Y0(15) = Y0(13) - del
          
        X0(16) = X0(15)
        Y0(16) = -Y0(15)
        
Dim i%
        For i = 1 To 16
             X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
             Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
        Next i
Dim GrChild As Graphic
            'Add child Graphics
' ##########################################################################
' ##########################################################################
        If ScrewView = "Front" Then
           ScrewView = "FrontSection"
            Gr.Properties("ScrewView") = ScrewView
        End If
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
            End With
            GrChild.Cosmetic = True
            GrChild.Closed = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
            End With
            GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
        
        'Threading
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
            End With
            GrChild.Cosmetic = True
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Cosmetic = True
            GrChild.Properties("PenColor") = PColor
       End If

' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then

' View Top
Dim R1#
            R1 = D / 2 - dd / 2 * T / H
            
            X0(1) = Sqr(D / 2# * D / 2# - J / 2# * J / 2#)
            Y0(1) = J / 2#
              
            X0(2) = X0(1)
            Y0(2) = -Y0(1)
              
            X0(3) = Sqr(R1 * R1 - J / 2# * J / 2#)
            Y0(3) = Y0(1)
              
            X0(4) = X0(3)
            Y0(4) = -Y0(3)
              
            X0(5) = R1
            Y0(5) = 0#
              
            X0(6) = -X0(1)
            Y0(6) = Y0(1)
              
            X0(7) = -X0(2)
            Y0(7) = Y0(2)
              
            X0(8) = -X0(3)
            Y0(8) = Y0(3)
              
            X0(9) = -X0(4)
            Y0(9) = Y0(4)
              
            X0(10) = -X0(5)
            Y0(10) = Y0(5)
              
            X0(11) = 0
            Y0(11) = D / 2
              
            X0(12) = X0(11)
            Y0(12) = -Y0(11)
            For i = 1 To 12
                X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
            Next i
'------------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(6), Y(6), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(2), Y(2), 0, True, True
                .Add X(4), Y(4), 0, True, True
            End With
            
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(9), Y(9), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(3), Y(3), 0#, X(5), Y(5), 0#, X(4), Y(4), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(10), Y(10), 0#, X(9), Y(9), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(1), Y(1), 0#, X(11), Y(11), 0#, X(6), Y(6), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(2), Y(2), 0#, X(12), Y(12), 0#, X(7), Y(7), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(7), Y(7), 0, False, True
                .Add X(2), Y(2), 0, True, True
            End With
            GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor

           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(3), Y(3), 0#, X(5), Y(5), 0#, X(4), Y(4), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(10), Y(10), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(1), Y(1), 0#, X(11), Y(11), 0#, X(6), Y(6), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(2), Y(2), 0#, X(12), Y(12), 0#, X(7), Y(7), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp

            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                      
        End If

End Sub

Private Sub HexBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, T#, J#, del#, E#, F#
        D = 1.75 * dd
        H = 0.65 * dd
        E = 0.875 * H
        F = D / 4#
        del = 0.1 * dd
Dim X0(23)
Dim Y0(23)
Dim X(23)
Dim Y(23)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = dd / 2#
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2# - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)
'-----------------------------------------------------------
       X0(7) = X0(1)
       Y0(7) = D / 2#
       
       X0(8) = X0(1)
       Y0(8) = -Y0(7)
       
       X0(9) = X0(1)
       Y0(9) = F
       
       X0(10) = X0(1)
       Y0(10) = -Y0(9)
       
       X0(11) = -E
       Y0(11) = D / 2#
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
       
       X0(13) = -H
       Y0(13) = D / 2# - (H - E) / Sin(Pi / 3)
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
       
       X0(15) = X0(11)
       Y0(15) = Y0(9)
       
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
       
       X0(17) = -H
       Y0(17) = 3# / 2# * F
       
       X0(18) = X0(17)
       Y0(18) = 0#
       
       X0(19) = X0(17)
       Y0(19) = -Y0(17)
                   
 '-------------------------------
        If LThread > 0 Then
            X0(20) = X0(5) - LThread
        Else
            X0(20) = X0(5) - del
        End If
       Y0(20) = dd / 2#
 
       X0(21) = X0(20)
       Y0(21) = -Y0(20)
       
       X0(22) = X0(20)
       Y0(22) = Y0(20) - del
       
       X0(23) = X0(22)
       Y0(23) = -Y0(22)
       
Dim i%
       For i = 1 To 23
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
' ##########################################################################
' ##########################################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
            
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
            End With
            GrChild.Closed = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
                
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(11), Y(11), 0#, X(17), Y(17), 0#, X(15), Y(15), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(15), Y(15), 0#, X(18), Y(18), 0#, X(16), Y(16), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '16
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(16), Y(16), 0#, X(19), Y(19), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(20), Y(20), 0, True, True, False, False, False, False
                .Add X(21), Y(21), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenColor") = PColor
            With GrChild.Vertices
                .Add X(22), Y(22), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(23), Y(23), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
       End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Front" Then
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
                For i = 1 To 23
                    X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                    Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
                Next i
           With GrChild.Vertices
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
            End With
            GrChild.Closed = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
           With GrChild.Vertices
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(11), Y(11), 0#, X(17), Y(17), 0#, X(15), Y(15), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(15), Y(15), 0#, X(18), Y(18), 0#, X(16), Y(16), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '16
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(16), Y(16), 0#, X(19), Y(19), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                        Gr.Vertices.Item(1).X = X(7)
                        Gr.Vertices.Item(1).Y = Y(7)
           
                        Gr.Vertices.Item(2).X = X(7)
                        Gr.Vertices.Item(2).Y = Y(7)
                        Gr.Vertices.Item(2).Editable = False
                        Gr.Vertices.Item(2).Selectable = False
           
                      
    '-------------------------------------------------------------
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
' View Top
            With GrChild.Vertices
                For i = 0 To 6
                    X0(i) = D / 2 * Cos(Pi / 3 * i)
                    Y0(i) = D / 2 * Sin(Pi / 3 * i)
                    X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                    Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
                    If i = 0 Then
                        Gr.Vertices.Item(1).X = X(i)
                        Gr.Vertices.Item(1).Y = Y(i)
                    End If
                   .Add X(i), Y(i), 0, True, True, False, False, False, False
                Next i
            End With
            GrChild.Closed = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            
            X(7) = X00 + D / 2 * Sin(Pi / 3)
            Y(7) = Y00
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(7), Y(7), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                      
        End If
        
End Sub

' Round Head Bolt

Private Sub RHBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, T#, J#, del#, E#, F#
        D = 2.1 * dd
        H = 0.531 * dd
        E = 0.8 * H
        F = D / 4#
        del = 0.1 * dd
Dim X0(13)
Dim Y0(13)
Dim X(13)
Dim Y(13)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = dd / 2#
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2# - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)
'-----------------------------------------------------------
       X0(7) = X0(1)
       Y0(7) = D / 2#
       
       X0(8) = X0(1)
       Y0(8) = -Y0(7)
       
       X0(9) = X0(1) - H
       Y0(9) = 0
       
                   
 '-------------------------------
        If LThread > 0 Then
            X0(10) = X0(5) - LThread
        Else
            X0(10) = X0(5) - del
        End If
       Y0(10) = dd / 2#
 
       X0(11) = X0(10)
       Y0(11) = -Y0(10)
       
       X0(12) = X0(10)
       Y0(12) = Y0(10) - del
       
       X0(13) = X0(12)
       Y0(13) = -Y0(12)
       
Dim i%
       For i = 1 To 13
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'##################################################################
'##################################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(9), Y(9), 0#, X(8), Y(8), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
                .Add X(7), Y(7), 0, False, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(9), Y(9), 0#, X(8), Y(8), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
'Thread
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
'##################################################################
'##################################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
                For i = 1 To 13
                    X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                    Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
                Next i
'-----------------------------------------------------------
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(9), Y(9), 0#, X(8), Y(8), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
                
                
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
           With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(9), Y(9), 0#, X(8), Y(8), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
    '-------------------------------------------------------------
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
' View Top
            
            X(1) = X00 + D / 2 * Calp
            Y(1) = Y00 + D / 2 * Salp
            Gr.Vertices.Item(1).X = X(1)
            Gr.Vertices.Item(1).Y = Y(1)
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(1), Y(1), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                      
        End If

End Sub

' T-Head Bolt

Private Sub THeadBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)
Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, del#, K#, F#
        D = 2# * dd
        H = 0.9 * dd
        F = 0.7 * H
        del = 0.1 * dd
Dim X0(19)
Dim Y0(19)
Dim X(19)
Dim Y(19)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = dd / 2#
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2# - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)
'-----------------------------------------------------------
       X0(7) = X0(1)
       Y0(7) = D / 2#
       
       X0(8) = X0(1)
       Y0(8) = -Y0(7)
       
       X0(9) = X0(1)
       Y0(9) = dd / 4#
       
       X0(10) = X0(1)
       Y0(10) = -Y0(9)
       
       X0(11) = X0(1) + dd / 4
       Y0(11) = dd / 4#
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
       
       X0(13) = -F
       Y0(13) = D / 2#
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
       
       X0(15) = -H
       Y0(15) = 0#
       
       
       
       
       
'Thread
 '-------------------------------
        If LThread > 0 Then
            X0(16) = X0(5) - LThread
        Else
            X0(16) = X0(5) - del
        End If
       Y0(16) = dd / 2#
 
       X0(17) = X0(16)
       Y0(17) = -Y0(16)
       
       X0(18) = X0(16)
       Y0(18) = Y0(16) - del
       
       X0(19) = X0(18)
       Y0(19) = -Y0(18)
       
Dim i%
       For i = 1 To 19
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(14), Y(14), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
                .Add X(13), Y(13), 0, False, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
            
                .Add X(14), Y(14), 0, False, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
    Dim Alp#
            Alp = Angle(Salp, Calp)
    
            Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(11), Y(11), 0, X(9), Y(9), 0, Pi + Alp, Pi + Pi / 4 + Alp)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
             GrChild.Properties("PenColor") = PColor
           Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(12), Y(12), 0, X(10), Y(10), 0, Pi - Pi / 4 + Alp, Pi + Alp)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
          '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                .Add X(17), Y(17), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
           Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(18), Y(18), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(19), Y(19), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
       End If
'##################################################################
'##################################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
                For i = 1 To 19
                    X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                    Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
                Next i
'-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(14), Y(14), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
           With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
    '-------------------------------------------------------------
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
' View Top
            X0(1) = D / 2
            Y0(1) = dd / 2
            
            X0(2) = -D / 2
            Y0(2) = dd / 2
            
            X0(3) = -D / 2
            Y0(3) = -dd / 2
           
            X0(4) = D / 2
            Y0(4) = -dd / 2
           
            X0(5) = D / 2
            Y0(5) = dd / 2
           Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                For i = 1 To 5
                    X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                    Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
                   .Add X(i), Y(i), 0, True, True, True, False, False, False
                Next i
            End With
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp
            
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                       
        End If

End Sub

'Square Bolt

Private Sub SquareBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, del#, E#
        D = 2.12 * dd
        H = 0.68 * dd
        E = 0.875 * H
        del = 0.1 * dd
Dim X0(20)
Dim Y0(20)
Dim X(20)
Dim Y(20)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = dd / 2#
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2# - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)
'-----------------------------------------------------------
       X0(7) = X0(1)
       Y0(7) = D / 2#
       
       X0(8) = X0(1)
       Y0(8) = -Y0(7)
       
       X0(9) = X0(1)
       Y0(9) = 0
       
       
       X0(10) = -E
       Y0(10) = D / 2#
       
       X0(11) = X0(10)
       Y0(11) = -Y0(10)
       
       X0(12) = -H
       Y0(12) = D / 2# - (H - E) / Sin(Pi / 3)
       
       X0(13) = X0(12)
       Y0(13) = -Y0(12)
       
       X0(14) = X0(10)
       Y0(14) = Y0(9)
       
       X0(15) = -H
       Y0(15) = dd / 2
       
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
       
                   
 '-------------------------------
        If LThread > 0 Then
            X0(17) = X0(5) - LThread
        Else
            X0(17) = X0(5) - del
        End If
       Y0(17) = dd / 2#
 
       X0(18) = X0(17)
       Y0(18) = -Y0(17)
       
       X0(19) = X0(17)
       Y0(19) = Y0(17) - del
       
       X0(20) = X0(19)
       Y0(20) = -Y0(19)
       
Dim i%
       For i = 1 To 20
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
' ##########################################################################
' ##########################################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
                
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, False, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False

                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(14), Y(14), 0#, X(16), Y(16), 0#, X(11), Y(11), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(17), Y(17), 0, True, True, False, False, False, False
                .Add X(18), Y(18), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(19), Y(19), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(20), Y(20), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2
            End If
            For i = 1 To 20
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
                
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(14), Y(14), 0#, X(16), Y(16), 0#, X(11), Y(11), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                        
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
    '-------------------------------------------------------------
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
' View Top
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                For i = 0 To 4
                    X0(i) = D / 2 * Cos(Pi / 2 * i)
                    Y0(i) = D / 2 * Sin(Pi / 2 * i)
                    X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                    Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
                    If i = 0 Then
                        Gr.Vertices.Item(1).X = X(i)
                        Gr.Vertices.Item(1).Y = Y(i)
                    End If
                   .Add X(i), Y(i), 0, True, True, False, False, False, False
                Next i
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            X(5) = X00 + D / 2 * Sin(Pi / 4)
            Y(5) = Y00
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(5), Y(5), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
    End If
End Sub

'Round Head Square Neck Bolt

Private Sub RHSNBolt(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, del#, P#, W#, E#
        D = 2.1 * dd
        H = 0.53 * dd
        P = 0.53 * dd
        W = 1.41 * dd
        E = P - (W - dd) / 2 * Tan(Pi / 6)
        del = 0.1 * dd
Dim X0(21)
Dim Y0(21)
Dim X(21)
Dim Y(21)
       
       X0(1) = 0#
       Y0(1) = W / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = X0(1) + E
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = X0(1) + P
       Y0(5) = dd / 2
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = L - del
       Y0(7) = Y0(5)
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = L
       Y0(9) = Y0(5) - del
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
'-----------------------------------------------------------
       X0(11) = X0(1)
       Y0(11) = 0#
       
       X0(12) = X0(1) + E
       Y0(12) = 0#
    
       X0(13) = X0(1)
       Y0(13) = D / 2
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
       
       X0(15) = X0(1) - H
       Y0(15) = 0#
                   
       X0(16) = X0(1) + P
       Y0(16) = W / 4
       
       X0(17) = X0(16)
       Y0(17) = -Y0(16)
 '-------------------------------
        If LThread > 0 Then
            X0(18) = X0(9) - LThread
        Else
            X0(18) = X0(9) - del
        End If
       Y0(18) = dd / 2#
 
       X0(19) = X0(18)
       Y0(19) = -Y0(18)
       
       X0(20) = X0(18)
       Y0(20) = Y0(18) - del
       
       X0(21) = X0(20)
       Y0(21) = -Y0(20)
       
Dim i%
       For i = 1 To 21
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
' ##########################################################################
' ##########################################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(13), Y(13), 0, True
                .Add X(1), Y(1), 0, True
                .Add X(3), Y(3), 0, True
                .Add X(5), Y(5), 0, True
                .Add X(7), Y(7), 0, True
                .Add X(9), Y(9), 0, True
                .Add X(10), Y(10), 0, True
                .Add X(8), Y(8), 0, True
                .Add X(6), Y(6), 0, True
                .Add X(4), Y(4), 0, True
                .Add X(2), Y(2), 0, True
                .Add X(14), Y(14), 0, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, False, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(3), Y(3), 0#, X(16), Y(16), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '16
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(4), Y(4), 0#, X(17), Y(17), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(18), Y(18), 0, True, True, False, False, False, False
                .Add X(19), Y(19), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(20), Y(20), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(21), Y(21), 0, False, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
       End If
        
        
'##################################################################
'##################################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
            For i = 1 To 21
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
'-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True
                .Add X(14), Y(14), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
           With GrChild.Vertices
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(15), Y(15), 0#, X(14), Y(14), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X(13)
            Gr.Vertices.Item(1).Y = Y(13)
           
            Gr.Vertices.Item(2).X = X(13)
            Gr.Vertices.Item(2).Y = Y(13)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
    '-------------------------------------------------------------
        End If
' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
' View Top
            
            X(1) = X00 + D / 2 * Calp
            Y(1) = Y00 + D / 2 * Salp
            Gr.Vertices.Item(1).X = X(1)
            Gr.Vertices.Item(1).Y = Y(1)
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(1), Y(1), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If
End Sub

'Hex Flange Screw

Private Sub HexFlScrew(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, Dw#, Di#, C#, K1#, K#, E#, del#
        D = 1.4 * dd
        Dw = 2.08 * dd
        C = 0.15 * dd
        K1 = 0.43 * dd
        K = 0.97 * dd
        E = (K - K1) * 0.85
        Di = D * Sin(Pi / 3)
        del = 0.1 * dd
Dim X0(27)
Dim Y0(27)
Dim X(27)
Dim Y(27)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = Y0(1) - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = 0
       Y0(7) = Dw / 2
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = -C
       Y0(9) = Dw / 2
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
       
       X0(11) = -K1
       Y0(11) = D / 2
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
       
       X0(13) = -K1 - E
       Y0(13) = D / 2
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
       
       X0(15) = -K
       Y0(15) = Di / 2
       
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
       
       X0(17) = -K1
       Y0(17) = D / 4
       
       X0(18) = X0(17)
       Y0(18) = -Y0(17)
       
       X0(19) = X0(13)
       Y0(19) = Y0(17)
       
       X0(20) = X0(19)
       Y0(20) = -Y0(19)
       
       X0(21) = -K
       Y0(21) = 3 / 8 * D
       
       X0(22) = X0(21)
       Y0(22) = -Y0(21)
       
       X0(23) = -K
       Y0(23) = 0
       
 '-------------------------------
        If LThread > 0 Then
            X0(24) = X0(5) - LThread
        Else
            X0(24) = X0(5) - del
        End If
       Y0(24) = dd / 2#
 
       X0(25) = X0(24)
       Y0(25) = -Y0(24)
       
       X0(26) = X0(24)
       Y0(26) = Y0(24) - del
       
       X0(27) = X0(26)
       Y0(27) = -Y0(26)
       
Dim i%
       For i = 1 To 27
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'################################################################
'################################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
'------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
            
                .Add X(17), Y(17), 0, False, True, False, False, False, False
                .Add X(19), Y(19), 0, True, True, False, False, False, False
            
                .Add X(18), Y(18), 0, False, True, False, False, False, False
                .Add X(20), Y(20), 0, True, True, False, False, False, False
            
                .Add X(11), Y(11), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(21), Y(21), 0#, X(19), Y(19), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(14), Y(14), 0#, X(22), Y(22), 0#, X(20), Y(20), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '16
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(19), Y(19), 0#, X(23), Y(23), 0#, X(20), Y(20), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(24), Y(24), 0, True, True, False, False, False, False
                .Add X(25), Y(25), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(26), Y(26), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(27), Y(27), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
        
'#############################################################
'#############################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
            For i = 1 To 27
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Closed = True
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
                            
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(17), Y(17), 0, False, True, False, False, False, False
                .Add X(19), Y(19), 0, True, True, False, False, False, False
            
                .Add X(18), Y(18), 0, False, True, False, False, False, False
                .Add X(20), Y(20), 0, True, True, False, False, False, False
            
                .Add X(11), Y(11), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(13), Y(13), 0#, X(21), Y(21), 0#, X(19), Y(19), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(14), Y(14), 0#, X(22), Y(22), 0#, X(20), Y(20), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '16
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(19), Y(19), 0#, X(23), Y(23), 0#, X(20), Y(20), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If

' ##########################################################################
' ##########################################################################
        If ScrewView = "Top" Then
' View Top
            X(8) = X00 + Dw / 2
            Y(8) = Y00
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(8), Y(8), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = RGB(255, 255, 255)
            GrChild.Properties("BrushColor") = BColor

            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                For i = 0 To 6
                    X0(i) = D / 2 * Cos(Pi / 3 * i)
                    Y0(i) = D / 2 * Sin(Pi / 3 * i)
                    X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                    Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
                    If i = 0 Then
                        Gr.Vertices.Item(1).X = X(i)
                        Gr.Vertices.Item(1).Y = Y(i)
                    End If
                   .Add X(i), Y(i), 0, True, True, False, False, False, False
                Next i
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            X(7) = X00 + D / 2 * Sin(Pi / 3)
            Y(7) = Y00
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X(7), Y(7), 0)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                      
        End If

End Sub



'Slotted Pan Head Screw

Private Sub SPHScrew(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
        
Dim D#, H#, del#, J#, T#, R#
        D = 2# * dd
        H = 0.54 * dd
        R = 0.35 * dd
        J = 0.2 * dd
        T = 0.3 * dd
        del = 0.1 * dd
Dim X0(22)
Dim Y0(22)
Dim X(22)
Dim Y(22)
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2 - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = 0
       Y0(7) = D / 2
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = -H + R
       Y0(9) = Y0(7)
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
       
       X0(11) = -H
       Y0(11) = Y0(9) - R
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
    
       X0(13) = -H
       Y0(13) = J / 2
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
       
       X0(15) = X0(13) + T
       Y0(15) = Y0(13)
                   
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
       
       X0(17) = X0(13) + R
       Y0(17) = Y0(11)
       
       X0(18) = X0(17)
       Y0(18) = -Y0(17)
 
 '-------------------------------
        If LThread > 0 Then
            X0(19) = X0(5) - LThread
        Else
            X0(19) = X0(5) - del
        End If
       Y0(19) = dd / 2#
 
       X0(20) = X0(19)
       Y0(20) = -Y0(19)
       
       X0(21) = X0(19)
       Y0(21) = Y0(19) - del
       
       X0(22) = X0(21)
       Y0(22) = -Y0(21)
       
Dim i%
       For i = 1 To 22
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'#############################################################
'#############################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
Dim Alp#
            Alp = Angle(Salp, Calp)
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(11), Y(11), 0, True, True
                .Add X(13), Y(13), 0, True, True
                .Add X(15), Y(15), 0, True, True
                .Add X(16), Y(16), 0, True, True
                .Add X(14), Y(14), 0, True, True
                .Add X(12), Y(12), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcCenterAndPoint(X(17), Y(17), 0#, X(11), Y(11), 0#, Pi / 2 + Alp, Pi + Alp)
           Set GrChild = GrGroup.Graphics.AddArcCenterAndPoint(X(18), Y(18), 0#, X(12), Y(12), 0#, Pi + Alp, 3 * Pi / 2 + Alp)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '14
           Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(17), Y(17), 0#, X(11), Y(11), 0#, Pi / 2 + Alp, Pi + Alp)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(18), Y(18), 0#, X(12), Y(12), 0#, Pi + Alp, 3 * Pi / 2 + Alp)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(19), Y(19), 0, True, True, False, False, False, False
                .Add X(20), Y(20), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(21), Y(21), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(22), Y(22), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
'#############################################################
'#############################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2
            End If
            For i = 1 To 22
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
 '-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(11), Y(11), 0, True, True
                .Add X(13), Y(13), 0, True, True
                .Add X(15), Y(15), 0, True, True
                .Add X(16), Y(16), 0, True, True
                .Add X(14), Y(14), 0, True, True
                .Add X(12), Y(12), 0, True, True
            End With
 Dim xx#, yy#, xmid#, ymid#
            xmid = (X(9) + X(11)) / 2#
            ymid = (Y(9) + Y(11)) / 2#
            xx = X(17) + (xmid - X(17)) / Sin(Pi / 4)
            yy = Y(17) + (ymid - Y(17)) / Sin(Pi / 4)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(9), Y(9), 0#, xx, yy, 0#, X(11), Y(11), 0)
            
            xmid = (X(10) + X(12)) / 2#
            ymid = (Y(10) + Y(12)) / 2#
            xx = X(18) + (xmid - X(18)) / Sin(Pi / 4)
            yy = Y(18) + (ymid - Y(18)) / Sin(Pi / 4)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, xx, yy, 0#, X(12), Y(12), 0)
            
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
           Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(17), Y(17), 0#, X(11), Y(11), 0#, Pi / 2 + Alp - Pi / 2, Pi + Alp - Pi / 2)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcCenterAndPoint(X(18), Y(18), 0#, X(12), Y(12), 0#, Pi + Alp - Pi / 2, 3 * Pi / 2 + Alp - Pi / 2)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If
'##############################################################
'##############################################################
' View Top
         If ScrewView = "Top" Then
            X0(1) = Sqr(D / 2 * D / 2 - J / 2 * J / 2)
            Y0(1) = J / 2
            
            X0(2) = -X0(1)
            Y0(2) = Y0(1)
            
            X0(3) = X0(2)
            Y0(3) = -Y0(1)
            
            X0(4) = X0(1)
            Y0(4) = Y0(3)
            For i = 1 To 4
                X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
            Next i
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X00 + D / 2, Y00, 0)
                  GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp
            
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
       End If
End Sub



'Slotted Round Head Cap Screw

Private Sub RHCScrew(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
Dim X0(18)
Dim Y0(18)
Dim X(18)
Dim Y(18)
        
Dim D#, H#, del#, J#, T#
        D = 1.6 * dd
        H = 0.68 * dd
        J = 0.2 * dd
        T = 0.4 * dd
        del = 0.1 * dd
Dim R#
        R = (H * H + D * D / 4) / (2 * H)
Dim xc#, yc#, LL#, sinb#, cosb#, alp1#, alp2#
        xc = R - H
        yc = 0
        X0(7) = 0
        Y0(7) = D / 2
        LL = Sqr((X0(7) - xc) * (X0(7) - xc) + (Y0(7) - yc) * (Y0(7) - yc))
        sinb = (Y0(7) - yc) / LL
        cosb = (X0(7) - xc) / LL
        alp1 = Angle(sinb, cosb)
        
        X0(9) = -H
        Y0(9) = J / 2
        LL = Sqr((X0(9) - xc) * (X0(9) - xc) + (Y0(9) - yc) * (Y0(9) - yc))
        sinb = (Y0(9) - yc) / LL
        cosb = (X0(9) - xc) / LL
        alp2 = Angle(sinb, cosb)
        X0(13) = xc + R * Cos((alp1 + alp2) / 2)
        Y0(13) = yc + R * Sin((alp1 + alp2) / 2)
        
        X0(14) = X0(13)
        Y0(14) = -Y0(13)
       
        
       
       X0(1) = 0#
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2 - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = 0
       Y0(7) = D / 2
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = -H
       Y0(9) = J / 2
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
       
       X0(11) = -H + T
       Y0(11) = Y0(9)
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
    
 
 '-------------------------------
        If LThread > 0 Then
            X0(15) = X0(5) - LThread
        Else
            X0(15) = X0(5) - del
        End If
       Y0(15) = dd / 2#
 
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
       
       X0(17) = X0(15)
       Y0(17) = Y0(15) - del
       
       X0(18) = X0(17)
       Y0(18) = -Y0(17)
       
Dim i%
       For i = 1 To 18
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'#############################################################
'#############################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(11), Y(11), 0, True, True
                .Add X(12), Y(12), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(13), Y(13), 0#, X(9), Y(9), 0#)
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(14), Y(14), 0#, X(10), Y(10), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, False, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
    Dim Alp#
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(13), Y(13), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(14), Y(14), 0#, X(10), Y(10), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(17), Y(17), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(18), Y(18), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
        
'##############################################################
'##############################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2

            End If
            For i = 1 To 18
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
'-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(11), Y(11), 0, True, True
                .Add X(12), Y(12), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(13), Y(13), 0#, X(9), Y(9), 0#)
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(14), Y(14), 0#, X(10), Y(10), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(13), Y(13), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(14), Y(14), 0#, X(10), Y(10), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If
'##############################################################
'##############################################################
' View Top
         If ScrewView = "Top" Then
         
Dim rr#
            rr = Sqr(R * R - (R - T) * (R - T))
            
            X0(1) = rr
            Y0(1) = J / 2
            
            X0(2) = -X0(1)
            Y0(2) = Y0(1)
            
            X0(3) = X0(2)
            Y0(3) = -Y0(1)
            
            X0(4) = X0(1)
            Y0(4) = Y0(3)
            
            X0(5) = X0(1)
            Y0(5) = Y0(1)
            
            For i = 1 To 5
                X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
            Next i
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X00 + D / 2, Y00, 0)
                  GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
           End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp
            
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
       End If
        
        

End Sub


'Slotted Oval Countersunk Head Screw

Private Sub SOCHScrew(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
Dim X0(20)
Dim Y0(20)
Dim X(20)
Dim Y(20)
        
Dim D#, K#, del#, F#, J#, T#
        D = 2# * dd
        K = 0.5 * dd
        F = 0.23 * dd
        J = 0.26 * dd
        T = 0.4 * dd
        del = 0.1 * dd
Dim R#
        R = (F * F + D * D / 4) / (2 * F)
Dim xc#, yc#, LL#, sinb#, cosb#, alp1#, alp2#
        xc = R - F
        yc = 0
        X0(7) = 0
        Y0(7) = D / 2
        LL = Sqr((X0(7) - xc) * (X0(7) - xc) + (Y0(7) - yc) * (Y0(7) - yc))
        sinb = (Y0(7) - yc) / LL
        cosb = (X0(7) - xc) / LL
        alp1 = Angle(sinb, cosb)
        
        X0(9) = -F
        Y0(9) = J / 2
        LL = Sqr((X0(9) - xc) * (X0(9) - xc) + (Y0(9) - yc) * (Y0(9) - yc))
        sinb = (Y0(9) - yc) / LL
        cosb = (X0(9) - xc) / LL
        alp2 = Angle(sinb, cosb)
        X0(15) = xc + R * Cos((alp1 + alp2) / 2)
        Y0(15) = yc + R * Sin((alp1 + alp2) / 2)
        
        X0(16) = X0(15)
        Y0(16) = -Y0(15)
       
        
       
       X0(1) = K
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2 - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = 0
       Y0(7) = D / 2
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = -F
       Y0(9) = J / 2
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
       
       X0(11) = -F + T
       Y0(11) = Y0(9)
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
    
       X0(13) = 0
       Y0(13) = Y0(9)
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
 
 '-------------------------------
        If LThread > 0 Then
            X0(17) = X0(5) - LThread
        Else
            X0(17) = X0(5) - del
        End If
       Y0(17) = dd / 2#
 
       X0(18) = X0(17)
       Y0(18) = -Y0(17)
       
       X0(19) = X0(17)
       Y0(19) = Y0(17) - del
       
       X0(20) = X0(19)
       Y0(20) = -Y0(19)
       
Dim i%
       For i = 1 To 20
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'#############################################################
'#############################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(11), Y(11), 0, True, True
                .Add X(12), Y(12), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(15), Y(15), 0#, X(9), Y(9), 0#)
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(16), Y(16), 0#, X(10), Y(10), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(12), Y(12), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, False, True, False, False, False, False
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(7), Y(7), 0, False, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
    Dim Alp#
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(15), Y(15), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(16), Y(16), 0#, X(10), Y(10), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(17), Y(17), 0, True, True, False, False, False, False
                .Add X(18), Y(18), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(19), Y(19), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(20), Y(20), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
       End If
'##############################################################
'##############################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2
            End If
            For i = 1 To 20
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
'-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(13), Y(13), 0, True, True
                .Add X(9), Y(9), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(15), Y(15), 0#, X(9), Y(9), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(8), Y(8), 0, True, True
                .Add X(14), Y(14), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(16), Y(16), 0#, X(10), Y(10), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            
            
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(14), Y(14), 0, False, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(7), Y(7), 0#, X(15), Y(15), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(16), Y(16), 0#, X(10), Y(10), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If
        
'#################################################################
'#################################################################
        If ScrewView = "Top" Then
' View Top
Dim R1#
            R1 = D / 2 - dd / 2 * (T - F) / K
            
            X0(1) = Sqr(D / 2# * D / 2# - J / 2# * J / 2#)
            Y0(1) = J / 2#
              
            X0(2) = X0(1)
            Y0(2) = -Y0(1)
              
            X0(3) = Sqr(R1 * R1 - J / 2# * J / 2#)
            Y0(3) = Y0(1)
              
            X0(4) = X0(3)
            Y0(4) = -Y0(3)
              
            X0(5) = R1
            Y0(5) = 0#
              
            X0(6) = -X0(1)
            Y0(6) = Y0(1)
              
            X0(7) = -X0(2)
            Y0(7) = Y0(2)
              
            X0(8) = -X0(3)
            Y0(8) = Y0(3)
              
            X0(9) = -X0(4)
            Y0(9) = Y0(4)
              
            X0(10) = -X0(5)
            Y0(10) = Y0(5)
              
            X0(11) = 0
            Y0(11) = D / 2
              
            X0(12) = X0(11)
            Y0(12) = -Y0(11)
            For i = 1 To 12
                X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
            Next i
'------------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(6), Y(6), 0, True, True
                .Add X(8), Y(8), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(2), Y(2), 0, True, True
                .Add X(4), Y(4), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True
                .Add X(9), Y(9), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(3), Y(3), 0#, X(5), Y(5), 0#, X(4), Y(4), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(10), Y(10), 0#, X(9), Y(9), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(1), Y(1), 0#, X(11), Y(11), 0#, X(6), Y(6), 0#)
            Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(2), Y(2), 0#, X(12), Y(12), 0#, X(7), Y(7), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(7), Y(7), 0, False, True
                .Add X(2), Y(2), 0, True, True
            End With
            GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor

           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(3), Y(3), 0#, X(5), Y(5), 0#, X(4), Y(4), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(8), Y(8), 0#, X(10), Y(10), 0#, X(9), Y(9), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(1), Y(1), 0#, X(11), Y(11), 0#, X(6), Y(6), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(2), Y(2), 0#, X(12), Y(12), 0#, X(7), Y(7), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp

            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
                      
        End If

End Sub


'Slotted Fillister Head Cap Screw

Private Sub SFHCScrew(Gr As Graphic, dd As Double, L As Double, Salp As Double, Calp As Double, ScrewView As String, ScrewViewOld As String, LThread As Double)

Dim X00#, Y00#, X01#, Y01#
        With Gr.Vertices
            X00 = .Item(0).X
            Y00 = .Item(0).Y
            X01 = .Item(1).X
            Y01 = .Item(1).Y
        End With
Dim X0(22)
Dim Y0(22)
Dim X(22)
Dim Y(22)
        
Dim D#, H#, del#, F#, J#, T#
        D = 1.3 * dd
        H = 0.77 * dd
        F = 0.65 * dd
        J = 0.175 * dd
        T = 0.33 * dd
        del = 0.1 * dd
Dim R#
        R = ((H - F) * (H - F) + D * D / 4) / (2 * (H - F))
Dim xc#, yc#, LL#, sinb#, cosb#, alp1#, alp2#
        xc = R - H
        yc = 0
        X0(9) = -F
        Y0(9) = D / 2
        LL = Sqr((X0(9) - xc) * (X0(9) - xc) + (Y0(9) - yc) * (Y0(9) - yc))
        sinb = (Y0(9) - yc) / LL
        cosb = (X0(9) - xc) / LL
        alp1 = Angle(sinb, cosb)
        
        X0(11) = -H
        Y0(11) = J / 2
        LL = Sqr((X0(11) - xc) * (X0(11) - xc) + (Y0(11) - yc) * (Y0(11) - yc))
        sinb = (Y0(11) - yc) / LL
        cosb = (X0(11) - xc) / LL
        alp2 = Angle(sinb, cosb)
        X0(17) = xc + R * Cos((alp1 + alp2) / 2)
        Y0(17) = yc + R * Sin((alp1 + alp2) / 2)
        
        X0(18) = X0(17)
        Y0(18) = -Y0(17)
       
        
       
       X0(1) = 0
       Y0(1) = dd / 2#
       
       X0(2) = X0(1)
       Y0(2) = -Y0(1)
       
       X0(3) = L - del
       Y0(3) = Y0(1)
       
       X0(4) = X0(3)
       Y0(4) = -Y0(3)
       
       X0(5) = L
       Y0(5) = dd / 2 - del
       
       X0(6) = X0(5)
       Y0(6) = -Y0(5)

       X0(7) = 0
       Y0(7) = D / 2
       
       X0(8) = X0(7)
       Y0(8) = -Y0(7)

       X0(9) = -F
       Y0(9) = D / 2
       
       X0(10) = X0(9)
       Y0(10) = -Y0(9)
       
       X0(11) = -H
       Y0(11) = J / 2
       
       X0(12) = X0(11)
       Y0(12) = -Y0(11)
    
       X0(13) = X0(11) + T
       Y0(13) = Y0(11)
       
       X0(14) = X0(13)
       Y0(14) = -Y0(13)
 
       X0(15) = X0(11) + (H - F)
       Y0(15) = Y0(11)
       
       X0(16) = X0(15)
       Y0(16) = -Y0(15)
 '-------------------------------
        If LThread > 0 Then
            X0(19) = X0(5) - LThread
        Else
            X0(19) = X0(5) - del
        End If
       Y0(19) = dd / 2#
 
       X0(20) = X0(19)
       Y0(20) = -Y0(19)
       
       X0(21) = X0(19)
       Y0(21) = Y0(19) - del
       
       X0(22) = X0(21)
       Y0(22) = -Y0(21)
       
Dim i%
       For i = 1 To 22
          X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
          Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
       Next i
Dim GrChild As Graphic
            'Add child Graphics
'#############################################################
'#############################################################
        If ScrewView = "FrontSection" Then
            Gr.Vertices.Item(2).Editable = True
            Gr.Vertices.Item(2).Selectable = True
'-----------------------------------------------------------
Dim GrGroup As Graphic
Dim GrHatch As Graphic
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(1), Y(1), 0, True, True
                .Add X(3), Y(3), 0, True, True
                .Add X(5), Y(5), 0, True, True
                .Add X(6), Y(6), 0, True, True
                .Add X(4), Y(4), 0, True, True
                .Add X(2), Y(2), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(11), Y(11), 0, True, True
                .Add X(13), Y(13), 0, True, True
                .Add X(14), Y(14), 0, True, True
                .Add X(12), Y(12), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(9), Y(9), 0#, X(17), Y(17), 0#, X(11), Y(11), 0#)
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(18), Y(18), 0#, X(12), Y(12), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
                
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
    Dim Alp#
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(9), Y(9), 0#, X(17), Y(17), 0#, X(11), Y(11), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(18), Y(18), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
                      
    '-------------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(19), Y(19), 0, True, True, False, False, False, False
                .Add X(20), Y(20), 0, True, True, False, False, False, False
            End With
             GrChild.Properties("PenColor") = PColor
           Set GrChild = Gr.Graphics.Add(gkGraphic)
                      GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(21), Y(21), 0, True, True, False, False, False, False
                .Add X(5), Y(5), 0, True, True, False, False, False, False
                .Add X(22), Y(22), 0, False, True, False, False, False, False
                .Add X(6), Y(6), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenColor") = PColor
        End If
'##############################################################
'##############################################################
        If ScrewView = "Front" Then
            If ScrewViewOld = "FrontSection" Then
Dim Calp2#, Salp2#
                Calp2 = Calp
                Salp2 = Salp
                Calp = -Salp2
                Salp = Calp2
            End If
            For i = 1 To 22
                X(i) = X00 + X0(i) * Salp + Y0(i) * Calp
                Y(i) = Y00 - X0(i) * Calp + Y0(i) * Salp
            Next i
'-----------------------------------------------------------
            'Set GrGroup = Gr.Graphics.Add(gkGraphic)
            Set GrGroup = Gr.Drawing.Graphics.Add(gkGraphic)
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(9), Y(9), 0, True, True
                .Add X(7), Y(7), 0, True, True
                .Add X(8), Y(8), 0, True, True
                .Add X(10), Y(10), 0, True, True
            End With
            Set GrChild = GrGroup.Graphics.Add(gkGraphic)
            With GrChild.Vertices
                .Add X(11), Y(11), 0, True, True
                .Add X(13), Y(13), 0, True, True
                .Add X(14), Y(14), 0, True, True
                .Add X(12), Y(12), 0, True, True
            End With
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(9), Y(9), 0#, X(17), Y(17), 0#, X(11), Y(11), 0#)
           Set GrChild = GrGroup.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(18), Y(18), 0#, X(12), Y(12), 0#)
            Set GrHatch = GrGroup.Graphics.AddHatch
            GrHatch.Cosmetic = True
            GrHatch.Properties("BrushStyle") = "Solid"
            GrHatch.Properties("BrushColor") = BColor
            Gr.Drawing.Graphics.Remove GrHatch.Index
            Gr.Graphics.AddGraphic GrHatch
            GrGroup.Delete
            Set GrHatch = Nothing
            Set GrGroup = Nothing
'-----------------------------------------------------------
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(8), Y(8), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, True, True, False, False, False, False
                .Add X(12), Y(12), 0, False, True, False, False, False, False
                .Add X(14), Y(14), 0, True, True, False, False, False, False
                .Add X(13), Y(13), 0, True, True, False, False, False, False
                .Add X(11), Y(11), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(7), Y(7), 0, True, True, False, False, False, False
                .Add X(9), Y(9), 0, False, True, False, False, False, False
                .Add X(15), Y(15), 0, True, True, False, False, False, False
                .Add X(10), Y(10), 0, False, True, False, False, False, False
                .Add X(16), Y(16), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Alp = Angle(Salp, Calp)
           '14
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(9), Y(9), 0#, X(17), Y(17), 0#, X(11), Y(11), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
           '15
           Set GrChild = Gr.Graphics.AddArcTriplePoint(X(10), Y(10), 0#, X(18), Y(18), 0#, X(12), Y(12), 0#)
                      GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X(7)
            Gr.Vertices.Item(1).Y = Y(7)
           
            Gr.Vertices.Item(2).X = X(7)
            Gr.Vertices.Item(2).Y = Y(7)
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
        End If
'##############################################################
'##############################################################
' View Top
         If ScrewView = "Top" Then
            X0(1) = Sqr(D / 2 * D / 2 - J / 2 * J / 2)
            Y0(1) = J / 2
            
            X0(2) = -X0(1)
            Y0(2) = Y0(1)
            
            X0(3) = X0(2)
            Y0(3) = -Y0(1)
            
            X0(4) = X0(1)
            Y0(4) = Y0(3)
            For i = 1 To 4
                X(i) = X00 + X0(i) * Calp - Y0(i) * Salp
                Y(i) = Y00 + X0(i) * Salp + Y0(i) * Calp
            Next i
            Set GrChild = Gr.Graphics.AddCircleCenterAndPoint(X00, Y00, 0, X00 + D / 2, Y00, 0)
                  GrChild.Cosmetic = True
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            GrChild.Properties("BrushStyle") = "Solid"
            GrChild.Properties("BrushColor") = BColor
            Set GrChild = Gr.Graphics.Add(gkGraphic)
                  GrChild.Cosmetic = True
            With GrChild.Vertices
                .Add X(1), Y(1), 0, True, True, False, False, False, False
                .Add X(2), Y(2), 0, True, True, False, False, False, False
                .Add X(3), Y(3), 0, False, True, False, False, False, False
                .Add X(4), Y(4), 0, True, True, False, False, False, False
            End With
            GrChild.Properties("PenWidth") = 0.02
            GrChild.Properties("PenColor") = PColor
            Gr.Vertices.Item(1).X = X00 + D / 2 * Calp
            Gr.Vertices.Item(1).Y = Y00 + D / 2 * Salp
            
            Gr.Vertices.Item(2).X = Gr.Vertices.Item(1).X
            Gr.Vertices.Item(2).Y = Gr.Vertices.Item(1).Y
            Gr.Vertices.Item(2).Editable = False
            Gr.Vertices.Item(2).Selectable = False
       End If

End Sub


