VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Bearing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'/******************************************************************/
'/*                                                                */
'/*                      TurboCAD for Windows                      */
'/*                   Copyright (c) 1993 - 2001                    */
'/*             International Microcomputer Software, Inc.         */
'/*                            (IMSI)                              */
'/*                      All rights reserved.                      */
'/*                                                                */
'/******************************************************************/

'DBAPI constants
Const gkGraphic = 11
Const gkArc = 2
Const gkText = 6
Const gfCosmetic = 128&

'Useful math constants
Const Pi# = 3.14159265

'Real variant types!
Const typeEmpty = 0
Const typeInteger = 2
Const typeLong = 3
Const typeSingle = 4
Const typeDouble = 5
Const typeCurrency = 6
Const typeDate = 7
Const typeString = 8
Const typeObject = 9
Const typeBoolean = 11
Const typeVariant = 12
Const typeIntegerEnum = typeInteger + 100
Const typeLongEnum = typeLong + 100
Const typeStringEnum = typeString + 100

'Stock property pages
Const ppStockPen = 1
Const ppStockBrush = 2
Const ppStockText = 4
Const ppStockInsert = 8
Const ppStockViewport = 16
Const ppStockAuto = 32

'Property Ids
Const idTeethNum = 1
Const IdD0 = 2
Const idH0 = 3
Const IdD1 = 4
Const IdD2 = 5
Const idH1 = 6
Const IdDi = 7
Const idH2 = 8
Const idH3 = 9
Const idH4 = 10
'Property enums

'Number of properties, pages, wizards
Const NUM_PROPERTIES = 10
Const NUM_PAGES = 1
Const NUM_WIZARDS = 0
Const formCaption = "Gear with Ball Bearing"
Private Sub Class_Initialize()
    'Initialize class variables
End Sub

'Returns the user-visible description of this RegenMethod
Public Property Get Description() As String
    Description = "SDK Gear"
End Property

'Returns the persistent class id for this RegenMethod's property section
Public Property Get ClassID() As String
    ClassID = "{D25185FF-6A20-11d0-A115-00A024158DAF}"
End Property

'Retrieve types and names
Public Function GetPropertyInfo(Names As Variant, Types As Variant, _
    IDs As Variant, Defaults As Variant) As Long
    ReDim Names(NUM_PROPERTIES), Types(NUM_PROPERTIES), _
        IDs(NUM_PROPERTIES), Defaults(NUM_PROPERTIES)
' Number of teeth on the gear
    Names(0) = "TeethNum"
    Types(0) = typeInteger
    IDs(0) = idTeethNum
    Defaults(0) = 40
    
    Names(1) = "D0"
    Types(1) = typeDouble
    IDs(1) = IdD0
    Defaults(1) = 3.5

    Names(2) = "H0"
    Types(2) = typeDouble
    IDs(2) = idH0
    Defaults(2) = 0.5
    
    Names(3) = "D1"
    Types(3) = typeDouble
    IDs(3) = IdD1
    Defaults(3) = 2.5
    
    Names(4) = "D2"
    Types(4) = typeDouble
    IDs(4) = IdD2
    Defaults(4) = 1.5
    
    Names(5) = "H1"
    Types(5) = typeDouble
    IDs(5) = idH1
    Defaults(5) = 0.25
    
    Names(6) = "Di"
    Types(6) = typeDouble
    IDs(6) = IdDi
    Defaults(6) = 1#
    
    Names(7) = "H2"
    Types(7) = typeDouble
    IDs(7) = idH2
    Defaults(7) = 0.75

    Names(8) = "H3"
    Types(8) = typeDouble
    IDs(8) = idH3
    Defaults(8) = 1.5

    Names(9) = "H4"
    Types(9) = typeDouble
    IDs(9) = idH4
    Defaults(9) = 1#
    
    GetPropertyInfo = NUM_PROPERTIES
End Function

'Get the number of property pages supporting this RegenMethod
Public Function GetPageInfo(ByVal AGraphic As Object, StockPages As Long, _
    Names As Variant) As Long
    ReDim Names(NUM_PAGES)

    'Need the form
''    Load frmGear
''    Names(0) = frmGear.Caption
''    Unload frmGear
    Names(0) = formCaption
    StockPages = ppStockBrush + ppStockPen + ppStockAuto
    GetPageInfo = NUM_PAGES
End Function

Public Function GetWizardInfo(Names As Variant) As Long
    ReDim Names(NUM_WIZARDS)
    GetWizardInfo = NUM_WIZARDS
End Function

'Enumerate the names and values of a specified property
Public Function GetEnumNames(ByVal PropID As Long, Names As Variant, Values As Variant) As Long
    GetEnumNames = 0
End Function

Public Function PageControls(ByVal ThisRegenMethod As Object, ByVal Graphic As Object, ByVal PageNumber As Long, ByVal SaveProperties As Boolean) As Boolean
        'Set up error function
        On Error GoTo Failed

        Dim TeethNum%, D0#, H0#, D1#, D2#, H1#, Di#, H2#, H3#, H4#
        If SaveProperties Then
            'OK button on property page was clicked
            'Form is still loaded
            With frmGear
                'Need On Error statement for the case where you have
                'RRect Turbo Shape and ahother "shape" selected
                On Error Resume Next

                'When the property page is closed, transfer the numeric
                'roundness value from the TextBox to the Graphic
                'Get the value as a double-precision number
                TeethNum = CInt(.txtTeethNum.Text)
                D0 = CDbl(.OutsideDiam.Text)
                H0 = CDbl(.H0.Text)
                D1 = CDbl(.D1.Text)
                D2 = CDbl(.D2.Text)
                H1 = CDbl(.H1.Text)
                Di = CDbl(.Di.Text)
                H2 = CDbl(.H2.Text)
                H3 = CDbl(.H3.Text)
                H4 = CDbl(.H4.Text)

                'Make sure it's between 0 and 100
                If TeethNum < 10 Then TeethNum = 10
                If D0 < 0 Then D0 = 1
                'Set the roundness property value in the Graphic
                Graphic.Properties("TeethNum") = TeethNum
                Graphic.Properties("D0") = D0
                Graphic.Properties("H0") = H0
                Graphic.Properties("D1") = D1
                Graphic.Properties("D2") = D2
                Graphic.Properties("H1") = H1
                Graphic.Properties("Di") = Di
                Graphic.Properties("H2") = H2
                Graphic.Properties("H3") = H3
                Graphic.Properties("H4") = H4
                 
                
            End With
        Else
            'Property page is about to be opened
            'Make sure the form is loaded
            Load frmGear
            With frmGear
                'If more than one RRect is selected and they do not
                'have the same properties, don't set up this field
                On Error GoTo NoRType

                'When the property page is opening, transfer the numeric
                'roundness value from the Graphic to the TextBox
                'Get the roundness property value from the Graphic
                TeethNum = Graphic.Properties("TeethNum")
                D0 = Graphic.Properties("D0")
                H0 = Graphic.Properties("H0")
                D1 = Graphic.Properties("D1")
                D2 = Graphic.Properties("D2")
                H1 = Graphic.Properties("H1")
                Di = Graphic.Properties("Di")
                H2 = Graphic.Properties("H2")
                H3 = Graphic.Properties("H3")
                H4 = Graphic.Properties("H4")
               'Set the TextBox control's text
                .txtTeethNum.Text = CStr(TeethNum)
                .OutsideDiam.Text = CStr(D0)
                .H0.Text = CStr(H0)
                .D1.Text = CStr(D1)
                .D2.Text = CStr(D2)
                .H1.Text = CStr(H1)
                .Di.Text = CStr(Di)
                .H2.Text = CStr(H2)
                .H3.Text = CStr(H3)
                .H4.Text = CStr(H4)
NoRType:
            End With
        End If

        PageControls = True
        Exit Function

Failed:
        'Return false if an error occurred
        PageControls = False
End Function

Public Function PageDone(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant)
        'Done with form
        Unload frmGear
End Function

Public Function PropertyPages(ByVal ThisRegenMethod As Object, Optional PageNumber As Variant) As Boolean
    With frmGear
        .Show vbModal
        PropertyPages = Not .DialogCanceled
    End With
End Function

Public Function Wizard(ByVal ThisRegenMethod As Object, Optional WizardNumber As Variant) As Boolean
    Wizard = False
End Function

'Called when vertex has been moved, or other geometry change
Public Function OnGeometryChanged(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant)
    'Do nothing
    'Regen Graphic
End Function

'Called when vertex is moved, or other geometry change
Public Function OnGeometryChanging(ByVal Graphic As Object, ByVal GeomID As Long, paramOld As Variant, paramNew As Variant) As Boolean
    'OK to continue with change
    OnGeometryChanging = True
End Function

Public Function OnNewGraphic(ByVal grfThis As Object, ByVal boolCopy As Boolean) As Boolean
    If boolCopy Then
        'Vertices are already added for us...
        OnNewGraphic = True
        Exit Function
    End If

    On Error GoTo Failed
    'New Graphic being created
    'X, Y, Z, PenDown, Selectable, Snappable, Editable, Linkable
    'First Vertex is "Center" of detail
    grfThis.Vertices.Add 5#, 5#, 0#, False, True, False, False, False
    
    OnNewGraphic = True
    Exit Function

Failed:
    'Return false on failure
    OnNewGraphic = False
End Function

'Function called whenever a copy of a graphic is being made
Public Function OnCopyGraphic(ByVal grfCopy As Object, ByVal grfSource As Object) As Boolean
    'Return false on failure
    OnCopyGraphic = True
End Function

'Notification function called after graphic property is saved
Public Function OnPropertyChanged(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant)
    'Do nothing
End Function

'Notification function called when graphic property is saved
Public Function OnPropertyChanging(ByVal Graphic As Object, ByVal PropID As Long, _
        ValueOld As Variant, ValueNew As Variant) As Boolean
    'OK to proceed
    OnPropertyChanging = True
End Function

'Notification function called when graphic property is retrieved
Public Function OnPropertyGet(ByVal Graphic As Object, ByVal PropID As Long)
    'Do nothing
End Function

'Called when we need to update our object
Public Function Regen(ByVal grfThis As Object)
        'Setup error handler
        On Error GoTo Failed

        'Set up lock (prevent recursion)
        Dim LockCount&
        LockCount& = grfThis.RegenLock
Dim NumCosm As Long, iCosm As Long
        iCosm = 1
        NumCosm = grfThis.Graphics.Count
        'Setup error handler (make sure lock is removed)
        On Error GoTo FailedLock
        If LockCount& = 0 Then
            'Add child Graphics
            Dim grfChild As Object
            Dim x0#, y0#, Z0#, x1#, y1#, Z1#
            With grfThis.Vertices
                x0# = .Item(0).X
                y0# = .Item(0).Y
                Z0# = .Item(0).Z
            End With
Dim TeethNum%
        TeethNum = grfThis.Properties("TeethNum")
            
Dim D0#, D1# 'External diameter
        D0 = grfThis.Properties("D0")
        D1 = grfThis.Properties("D1")

Dim n As Long
    n = TeethNum
Dim Rext#, Rint#, r1#, r2#, r3#
Dim fi#, dfi#, alp#, bet#, gam#
Dim xc#, yc#, zc#
Dim h#, H0#, H2#, H3#, H4#, H1#
        H0 = grfThis.Properties("H0")
Dim i As Long, j As Long
    Rext = D0 / 2
Dim m#
    m = D0 / (n + 2)
    h = 2.25 * m
    Rint = Rext - h
    r1 = D1 / 2
    xc = x0
    yc = y0
    zc = Z0 - H0
    dfi = 2 * Pi / n
    alp = Pi / 3 / n
    bet = Pi / 3 / n
    gam = Pi / 3 / n
Dim Vers As Vertices
Dim Ver As Vertex
Dim xi#, yi#, zi#
Dim grChild As Graphic
    zi = zc
    j = 0
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If

'###############################################################
    Set Vers = grChild.Vertices
    For i = 0 To n - 1
        fi = i * dfi
        If i = 0 Then
            xi = xc + Rint * Cos(fi - (alp + bet))
            yi = yc + Rint * Sin(fi - (alp + bet))
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
        j = j + 1
        xi = xc + Rext * Cos(fi - alp)
        yi = yc + Rext * Sin(fi - alp)
        Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        xi = xc + Rext * Cos(fi + alp)
        yi = yc + Rext * Sin(fi + alp)
        Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        xi = xc + Rint * Cos(fi + (alp + bet))
        yi = yc + Rint * Sin(fi + (alp + bet))
        Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        xi = xc + Rint * Cos(fi + (alp + bet + 2 * gam))
        yi = yc + Rint * Sin(fi + (alp + bet + 2 * gam))
        Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
    Next i
Dim xCon#, yCon#, zCon#
    xCon = xi
    yCon = yi
    zCon = zi
    
    dfi = 2 * Pi / 30
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + r1 * Cos(fi)
        yi = yc + r1 * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    
    grChild.Closed = True
    grChild.Properties("PenColor") = QBColor(8)
    grChild.Properties("Thickness") = 2 * H0
    grChild.Properties("Solid") = 0
    
    
' ----------------------------------------------------------------------
Dim D2#
        D2 = grfThis.Properties("D2")
        H1 = grfThis.Properties("H1")
    r1 = D1 / 2
    r2 = D2 / 2
    xc = x0
    yc = y0
    zc = Z0 - H1
    zi = zc
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################

    For i = 0 To 30
        fi = i * dfi
        xi = xc + r1 * Cos(fi)
        yi = yc + r1 * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + r2 * Cos(fi)
        yi = yc + r2 * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = QBColor(8)
    grChild.Properties("Thickness") = 2 * H1
    grChild.Properties("Solid") = 0
               
' ----------------------------------------------------------------------
Dim Di#, ri#
        Di = grfThis.Properties("Di")
        H2 = grfThis.Properties("H2")
    r2 = D2 / 2
    ri = Di / 2
    xc = x0
    yc = y0
    zc = Z0 - H2
    zi = zc
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
    For i = 0 To 30
        fi = i * dfi
        xi = xc + r2 * Cos(fi)
        yi = yc + r2 * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + ri * Cos(fi)
        yi = yc + ri * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = QBColor(8)
    grChild.Properties("Thickness") = 2 * H2
    grChild.Properties("Solid") = 0
' ----------------------------------------------------------------------
    H3 = grfThis.Properties("H3")
    xc = x0
    yc = y0
    zc = Z0 - H3
    zi = zc
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
    For i = 0 To 30
        fi = i * dfi
        xi = xc + ri * Cos(fi)
        yi = yc + ri * Sin(fi)
        zi = zc
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    grChild.Closed = True
    grChild.Properties("PenColor") = QBColor(8)
    grChild.Properties("Thickness") = 2 * H3
    grChild.Properties("Solid") = 0

' End gear
' --------------------------------------------------------------------------
' --------------------------------------------------------------------------
' --------------------------------------------------------------------------
' Begin Bearings  -  1
    H4 = grfThis.Properties("H4")

 Dim rb1#, rb2#, rb3#, rb4#
 Dim hb#
 Dim rr#
 Dim zb#
    rr = 0.2 * ri
    hb = 2 * rr
    zb = H4
    
'  First ring
    rb1 = ri
    rb2 = rb1 + hb / 4
    xc = x0
    yc = y0
    zi = zb
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
    For i = 0 To 30
        fi = i * dfi
        xi = xc + rb2 * Cos(fi)
        yi = yc + rb2 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + rb1 * Cos(fi)
        yi = yc + rb1 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = RGB(0, 0, 255)
    grChild.Properties("Thickness") = hb
    grChild.Properties("Solid") = 0
' --------------------------------------------------------------------

'  Second ring
    rb3 = rb2 + 2 * rr
    rb4 = rb3 + hb / 4
    xc = x0
    yc = y0
    zi = zb
    dfi = 2 * Pi / 30
 '###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
   For i = 0 To 30
        fi = i * dfi
        xi = xc + rb4 * Cos(fi)
        yi = yc + rb4 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + rb3 * Cos(fi)
        yi = yc + rb3 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = RGB(0, 0, 255)
    grChild.Properties("Thickness") = hb
    grChild.Properties("Solid") = 0
' --------------------------------------------------------------------
' Draw Bolls as spheres
    zi = zb + hb / 2
    dfi = 2 * Pi / 16
    For i = 0 To 16
        fi = i * dfi
        xi = xc + (rb2 + rr) * Cos(fi)
        yi = yc + (rb2 + rr) * Sin(fi)
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(, "TCW40SPHERE")
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################

        Set Ver = grChild.Vertices.Add(xi, yi, zi, False, False, False, False, False, False)
        Set Ver = grChild.Vertices.Add(xi, yi, zi + rr, False, False, False, False, False, False)
        grChild.Properties("PenColor") = QBColor(4)
        grChild.Properties("Solid") = 0
    Next i

' --------------------------------------------------------------------------
' --------------------------------------------------------------------------
' --------------------------------------------------------------------------
' Begin Bearings  -  2
    rr = 0.2 * ri
    hb = 2 * rr
    zb = -H4 - hb
    
'  First ring
    rb1 = ri
    rb2 = rb1 + hb / 4
    xc = x0
    yc = y0
    zi = zb
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
    For i = 0 To 30
        fi = i * dfi
        xi = xc + rb2 * Cos(fi)
        yi = yc + rb2 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + rb1 * Cos(fi)
        yi = yc + rb1 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = RGB(0, 0, 255)
    grChild.Properties("Thickness") = hb
    grChild.Properties("Solid") = 0
' --------------------------------------------------------------------

'  Second ring
    rb3 = rb2 + 2 * rr
    rb4 = rb3 + hb / 4
    xc = x0
    yc = y0
    zi = zb
    dfi = 2 * Pi / 30
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(11)
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
    For i = 0 To 30
        fi = i * dfi
        xi = xc + rb4 * Cos(fi)
        yi = yc + rb4 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    xCon = xi
    yCon = yi
    zCon = zi
    
    For i = 0 To 30
        fi = -i * dfi
        xi = xc + rb3 * Cos(fi)
        yi = yc + rb3 * Sin(fi)
        If i = 0 Then
            Set Ver = Vers.Add(xi, yi, zi, False, True, True, True, True, False)
        Else
            Set Ver = Vers.Add(xi, yi, zi, True, True, True, True, True, False)
        End If
    Next i
    Set Ver = Vers.Add(xCon, yCon, zCon, False, True, True, True, True, False)
    grChild.Closed = True
    grChild.Properties("PenColor") = RGB(0, 0, 255)
    grChild.Properties("Thickness") = hb
    grChild.Properties("Solid") = 0
' --------------------------------------------------------------------
' Draw Bolls as spheres
    zi = zb + hb / 2
    dfi = 2 * Pi / 16
    For i = 0 To 16
        fi = i * dfi
        xi = xc + (rb2 + rr) * Cos(fi)
        yi = yc + (rb2 + rr) * Sin(fi)
'###############################################################
If NumCosm < 2 Then
    Set grChild = grfThis.Graphics.Add(, "TCW40SPHERE")
        grChild.Cosmetic = True
Else
    Set grChild = grfThis.Graphics.Item(iCosm)
    grChild.Vertices.Clear
    iCosm = iCosm + 1
End If
Set Vers = grChild.Vertices
'###############################################################
        Set Ver = grChild.Vertices.Add(xi, yi, zi, False, False, False, False, False, False)
        Set Ver = grChild.Vertices.Add(xi, yi, zi + rr, False, False, False, False, False, False)
        grChild.Properties("PenColor") = QBColor(4)
        grChild.Properties("Solid") = 0
   Next i

            'Add visible child Graphics
        End If

        grfThis.RegenUnlock
        Exit Function

FailedLock:
        'Remove lock
        grfThis.RegenUnlock

Failed:
End Function

Public Function Draw(ByVal grfThis As Object, ByVal view As Object, Optional mat As Variant) As Boolean
    'Return True if we did the redraw (no further processing necessary, no children will be drawn).
    'Since this is just a test, we return False to let TurboCAD do the drawing operation.
    Draw = False
End Function


