VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "tcEventsHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2006                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'
' This sample demostrates how to use PointSnapped event

Option Explicit
Private m_bDrag As Boolean
Private m_lToolStatus As ToolStatus
Dim m_XStart, m_YStart As Single
Dim m_XOld, m_YOld As Single
Dim p As POINTAPI, l As Long, XorM As Long, Nullbrush As Long, OldNullbrush As Long
Dim m_xSnapped As Double, m_ySnapped As Double, m_zSnapped As Double
Dim m_xScreenSnapped As Long, m_yScreenSnapped As Long
Dim m_xStartScreenSnapped As Double, m_yStartScreenSnapped As Double
Dim m_lSDKLineToolPenColor As Long
Dim m_xStartSnapped As Double, m_yStartSnapped As Double, m_zStartSnapped As Double
Dim m_bInspectorBarFieldsAdded As Boolean
Dim m_bPointIsSnapped As Boolean        ' indicated if point we get in PointSnapped event was actually snap point

Public Function MouseUp(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Button As ImsiMouseButton, Shift As Long, X As Long, Y As Long, Cancel As Boolean)
        On Error GoTo ErrHandler
        If Button = imsiLeftButton Then
            Cancel = True
        End If
        Exit Function
ErrHandler:
        MsgBox "Mouse Down failed " & Err.Description
End Function
Public Function PointSnapped(WhichDrawing As Drawing, WhichView As View, X As Long, Y As Long, pvPick As Vertex, pvSnapped As Vertex)
    m_xSnapped = pvSnapped.X
    m_ySnapped = pvSnapped.Y
    m_zSnapped = pvSnapped.Z
    
    'we always get pvSnapped and pvPick in current CS coordinates
    Dim G As Graphic
    Set G = New XGraphic
    ' let's transform snapped point to World CS
    G.Vertices.Add pvSnapped.X, pvSnapped.Y, pvSnapped.Z
    G.Vertices.UseWorldCS = True
    m_xSnapped = G.Vertices(0).X
    m_ySnapped = G.Vertices(0).Y
    m_zSnapped = G.Vertices(0).Z
    ' if pvSnapped.Snappable  = true then point was actually processed with TurboCAD's snap system
    m_bPointIsSnapped = pvSnapped.Snappable
    Set G = Nothing
End Function

Public Function MouseDown(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Button As ImsiMouseButton, Shift As Long, X As Long, Y As Long, Cancel As Boolean)
    On Error GoTo ErrHandler
    Dim xView As Double, yView As Double, zView As Double
    Dim xScreen As Double, yScreen As Double
    Dim grLine As Graphic
    'Dim p As POINTAPI
    Dim bSnapsEnabled As Boolean
    Dim tcVersion As Double
    bSnapsEnabled = True
    
    If Button = imsiLeftButton Then
'        WhichView.WorldToView m_xSnapped, m_ySnapped, m_zSnapped, xView, yView, zView
        If (WhichDrawing.Application.SnapModes = 1 Or WhichDrawing.Application.SnapModes = 0) Then
            bSnapsEnabled = False
        End If
        tcVersion = getTCMajorVersion(WhichDrawing.Application.Version)
        If (tcVersion < 12) Then
            ' if version is less than 12 then no snaps, no seke
            m_bPointIsSnapped = True ' the PointSnapped event is implemented since v12
        End If

        If (m_bPointIsSnapped = False And bSnapsEnabled = True) Then
            'MsgBox "TurboCAD warning prompt", vbOKOnly, "TurboCAD warning", , LoadResString(118)
            'The requested operation cannot be completed.
            'A Snap mode is active with no snap points within the snap aperture.
            'Re-try the operation with snap disabled
            'let's  turbocad display warning message about snaps
            Exit Function
        End If
        
        Select Case m_ptcTool.Index
            Case SDKLineTools.SDKLine
                '''If (Not m_bDrag) Then
                    'm_bPointIsSnapped
                    If (m_bDrag = False) Then  ' first point of our line
                        m_xStartSnapped = m_xSnapped
                        m_yStartSnapped = m_ySnapped
                        m_zStartSnapped = m_zSnapped
                        '''WhichView.ViewToScreen xView, yView, m_xStartScreenSnapped, m_yStartScreenSnapped
                        ' our tool is 2D tool so we does't pass m_zSnapped to WorldToView function
                        WhichView.WorldToView m_xSnapped, m_ySnapped, 0, xView, yView, zView
                        WhichView.ViewToScreen xView, yView, xScreen, yScreen
                        
                        p.X = xScreen
                        p.Y = yScreen
                        m_XStart = p.X
                        m_YStart = p.Y
                        m_XOld = m_XStart
                        m_YOld = m_YStart
                        ClientToScreen WhichView.hwnd, p
                        SetCursorPos p.X, p.Y
                       m_lToolStatus = iFirstClick
                        m_bDrag = True
                        
                    Else
                        m_bDrag = False         ' second point of our line
                        Set grLine = WhichDrawing.Graphics.AddLineSingle(m_xStartSnapped, m_yStartSnapped, 0, m_xSnapped, m_ySnapped, 0)
                        grLine.Transform WhichDrawing.UCS
                        Set grLine = Nothing
                    End If
            
            Case SDKLineTools.SDKPolyline
                ' TO DO
                ' ADD your code here
        End Select
        Cancel = True
    End If
    Exit Function
ErrHandler:
    MsgBox "Mouse Down failed " & Err.Description
End Function
Public Function MouseMove(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Shift As Long, X As Long, Y As Long, Cancel As Boolean)
    Dim curPoint As POINTAPI
    Dim hdc As Long
    Dim m_hPenColor As Long, m_hPenOldColor As Long
    Dim Brush As Long, OldBrush As Long
    
    Dim penColor As Long
    If (m_bDrag = True) Then
        p.X = X
        p.Y = Y
        hdc = GetDC(WhichView.hwnd)
        m_hPenColor = CreatePen(0, 1, RGB(255, 255, 0))
        m_hPenOldColor = SelectObject(hdc, m_hPenColor)
        Brush = CreateSolidBrush(NULL_BRUSH)
        OldBrush = SelectObject(hdc, Brush)
        XorM = SetROP2(hdc, R2_XORPEN)
        curPoint.X = m_XStart
        curPoint.Y = m_YStart
        ' erase previous line

        Select Case m_ptcTool.Index
            Case SDKLineTools.SDKLine
                MoveToEx hdc, m_XStart, m_YStart, curPoint
                LineTo hdc, m_XOld, m_YOld
                    
                ' draw our line
                MoveToEx hdc, m_XStart, m_YStart, curPoint
                LineTo hdc, p.X, p.Y

            Case SDKLineTools.SDKPolyline
                ' TO DO
        End Select
        SelectObject hdc, m_hPenOldColor
        DeleteObject m_hPenColor
        SelectObject hdc, OldBrush
        DeleteObject Brush
        ReleaseDC WhichView.hwnd, hdc
        
        m_XOld = p.X
        m_YOld = p.Y
        
    
    End If
    



End Function
Public Function Terminate(ByVal objTool As Object)
    Call Finish
End Function

Public Function RunTool(WhichTool As Tool)
    On Error Resume Next
    'MsgBox "Run tool " & WhichTool.MenuText
    Call Finish
End Function

Public Function BeforeExit(WhichApplication As Application, Cancel As Boolean)
    Call Finish
End Function
Public Function DrawingNew(WhichDrawing As Drawing)
    On Error Resume Next
    Call Finish
End Function
Public Function DrawingOpen(WhichDrawing As Drawing)
    On Error Resume Next
    Call Finish
End Function
Public Function DrawingActivate(WhichDrawing As Drawing)
    On Error Resume Next
    'Call Finish
End Function
Public Function DrawingDeactivate(WhichDrawing As Drawing)
    On Error Resume Next
    'Call Finish
End Function
Public Function DrawingBeforeClose(WhichDrawing As Drawing, Cancel As Boolean)
    On Error Resume Next
    Call Finish
End Function
Public Function DrawingBeforeSave(WhichDrawing As Drawing, SaveAs As Boolean, Cancel As Boolean)
    On Error Resume Next
    Call Finish
End Function

Public Sub SelectionChange(objDwg As Object, objView As Object, objWnd As Object, objSel As Object)
    On Error Resume Next
    Call Finish
End Sub

Public Function WindowDeactivate(gxDwg As Drawing, WhichView As View, WhichWindow As Window)

End Function
Public Function Cancel(DoItPlease As Boolean, ByRef CanCancel As Boolean)
    If DoItPlease Then
        MsgBox "Cancel event command DoItPlease = " & DoItPlease
        Finish
    End If
    CanCancel = 0
End Function
Public Function CommandBarControlDone(whichControl As Object)
End Function
' handling commands from local menu
' the TurboCAD calls DoLMCommand method in case of selecting the local menu item of the SDK tool
' and pass index of local menu item
Public Function DoLMCommand(CmdInd As Long)
    Select Case m_ptcTool.Index
            Case SDKLineTools.SDKLine
                Select Case CmdInd
                    Case 0
                        'frmSettings.Show vbModal
                        'MsgBox "local menu Add"
                        If (m_bInspectorBarFieldsAdded = False) Then
                            SDKLineToolAddInspectorBarFields (True)
                            m_bInspectorBarFieldsAdded = True
                            SDKLineToolAddLocalMenu False
                            SDKLineToolAddLocalMenu True
                        End If
                    Case 1
                        'MsgBox "local menu Remove"
                        If (m_bInspectorBarFieldsAdded = True) Then
                            SDKLineToolAddInspectorBarFields (False)
                            SDKLineToolAddLocalMenu False
                            SDKLineToolAddLocalMenu True
                            m_bInspectorBarFieldsAdded = False
                        End If
                    
                    Case 2
                        Call Finish
                    Case Else
                End Select
            Case SDKLineTools.SDKPolyline
            ' TO DO add your processing here for SDKPolyline tool
    End Select
    ' rebuild local menu ' in our case to have item 2 checked/unchecked
    'AddLocalMenu True
End Function
Public Sub Finish()
    On Error Resume Next
    'm_theToolEvents.ToolChangePrompt Me, "", False
    ' remove our tool local menu items from local menu
    Select Case m_ptcTool.Index
            Case SDKLineTools.SDKLine
                SDKLineToolAddLocalMenu False
                SDKLineToolAddInspectorBarFields False
            Case SDKLineTools.SDKPolyline
    End Select

    If m_iConnectId <> 0 Then
        m_tcApp.DisconnectEvents m_iConnectId
    End If
    'AddLocalMenu False
    SDKLineToolAddLocalMenu False
    m_bRun(m_ptcTool.Index) = False
    Set m_ptcTool = Nothing
    Set m_theToolEvents = Nothing
    Set m_tcApp = Nothing
    
End Sub

Private Sub Class_Initialize()
    m_bDrag = False
    m_lToolStatus = iStarted
    m_lSDKLineToolPenColor = 0
    m_bInspectorBarFieldsAdded = False
    ghHook = 0
    m_bPointIsSnapped = False
End Sub

Private Sub Class_Terminate()
    Exit Sub
'    Call Finish
    Exit Sub
    If (Not m_theToolEvents Is Nothing) Then
        Set m_theToolEvents = Nothing
    End If
    If (Not m_tcApp Is Nothing) Then
       Set m_tcApp = Nothing
    End If
    Set m_ptcTool = Nothing
End Sub

Public Function getTCMajorVersion(sVer As String) As Long
    'Dim sVer As String
    Dim ind As Long
    getTCMajorVersion = 12
    On Error Resume Next
    Err.Clear
    ind = InStr(1, sVer, ".", 1)
    sVer = Left(sVer, ind - 1)
    getTCMajorVersion = CDbl(sVer)
    Err.Clear
End Function

