VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Contour"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Number of tools in this server
Const NUM_TOOLS = 1


' *******************************************************************
'    Const EventMask = 268435456 + 536870912
'    Const EventMask = 1024 + 268435456 + 536870912
    Const EventMask = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 1024 + 4096 + 262144 + 268435456 + 536870912

    Private iConnectId As Long
    Private iActTool As Long
    Private theToolEvents As IToolEvents


' *******************************************************************
'Toggle this to test loading buttons from .Bmp/.Res
Const boolLoadFromBmp As Boolean = False
Const boolDebug As Boolean = False
'##########################################################################
'##########################################################################
Private Declare Function TCWUndoClear Lib "TCAPI70.dll" () As Long
Private Declare Function TCWUndoRecordEnd Lib "TCAPI70.dll" (ByVal d As Long) As Long
Private Declare Function TCWUndoRecordStart Lib "TCAPI70.dll" (ByVal d As Long, ByRef Title As String) As Long
Private Declare Function TCWUndoRecordAddGraphic Lib "TCAPI70.dll" (ByVal d As Long, ByVal g As Long) As Long
Private Declare Function TCWUndo Lib "TCAPI70.dll" (ByVal N As Long) As Long

Private Declare Function TCWDrawingActive Lib "TCAPI70.dll" () As Long
Private Declare Function TCWGraphicAt Lib "TCAPI70.dll" (ByVal d As Long, ByVal Index As Long) As Long
Private Declare Function TCWVertexAt Lib "TCAPI70.dll" (ByVal g As Long, ByVal Index As Long) As Long

Private Declare Sub prVertexSetSomeFlags Lib "DBAPI70.dll" (ByVal hVer As Long, ByVal FlagOn As Long, ByVal FlagOff As Long)

Private Declare Function GraphicGetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long) As Long
Private Declare Function GraphicSetMatrix Lib "DBAPI70.dll" (ByVal hGr As Long, ByVal hMat As Long) As Boolean
Private Declare Function MatrixEqual Lib "DBAPI70.dll" (ByVal hM1 As Long, ByVal hM2 As Long) As Boolean

Private Declare Function TCWViewRedraw Lib "TCAPI70.dll" () As Long

Private hDr As Long
Private GrCon As Graphic

Type VertexTieData
    idVertPoly As Long ' define the least nearest index of segment's vertex on polygon
    xLocRelPrev As Double ' Previous local coordinate on line segment
    AnglePrev As Double ' Previous angle of line segment
    fiMidPrev As Double ' Previous angle for middle text point for Circle or Arc
    xcPrev As Double    ' Previous Xc for Circle or Arc
    ycPrev As Double    ' Previous Yc for Circle or Arc
    LFullPrev As Double     ' Previous full length for Curve or TCW50Polyline
    x0Prev As Double    ' Previous x0 for Curve or TCW50Polyline
    y0Prev As Double    ' Previous y0 for Curve or TCW50Polyline
    x1Prev As Double    ' Previous x1 for Curve or TCW50Polyline
    y1Prev As Double    ' Previous y1 for Curve or TCW50Polyline
    L0RelPrev As Double  ' Previous relative Length coordinate for the center vertex of the text
    L1RelPrev As Double ' Previous relative Length coordinate for the first bounded vertex of the text
    L2RelPrev As Double ' Previous relative Length coordinate for the first bounded vertex of the text
End Type



'Copy a windows bitmap of the requested size to the clipboard
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire bitmap:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono bitmap should be 1-bit (black or white)
Public Function CopyBitmap(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Boolean
    On Error GoTo BitmapError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        'Put the image on the Windows clipboard
        Clipboard.SetData TheImage, vbCFDIB
        CopyBitmap = True
        Exit Function
    End If

BitmapError:
    CopyBitmap = False
End Function

'Return a Picture object for the requested size
'Apparently, returning references to StdPicture objects doesn't work for .EXE servers
'Bitmaps returned should contain NUM_TOOLS images
'Size of entire image:
'Normal:  (NUM_TOOLS*16) wide x 15 high
'Large:   (NUM_TOOLS*24) wide x 23 high
'Mono image should be 1-bit (black or white)
Public Function GetPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean) As Object
    On Error GoTo PictureError

    Dim TheImage As New StdPicture
    If GetButtonPicture(LargeImage, MonoImage, TheImage) Then
        Set GetPicture = TheImage
        Exit Function
    End If

PictureError:
    Set GetPicture = Nothing
End Function

'Implementation specific stuff
'Private function to return the bitmap from .Res file or .Bmp file
Private Function GetButtonPicture(ByVal LargeImage As Boolean, ByVal MonoImage As Boolean, TheImage As StdPicture) As Boolean
    On Error GoTo LoadError

    'There are two ways to load images:  from .Bmp file(s) or from .RES resource.
    'In this demo, we control the loading by a private variable.
    
    'Note that if you are loading from .Bmp, or if you are running this tool as a
    '.VBP for debugging, you must place the .Res or .Bmp files in the Draggers subdirectory
    'of the directory in which TCW40.EXE (or IMSIGX40.DLL) is located.

    If boolLoadFromBmp Then
        'Load from .Bmp file
        Dim strFileName As String 'File name of .Bmp file to load

        If LargeImage Then
            strFileName = App.Path & "\button24.bmp"
        Else
            strFileName = App.Path & "\button16.bmp"
        End If
        Set TheImage = LoadPicture(strFileName)
    Else
        'Load from .Res file
        Dim idBitmap%  'BITMAP resource id in .Res file

        If LargeImage Then
            idBitmap% = 1002
        Else
            idBitmap% = 1001
        End If
        Set TheImage = LoadResPicture(idBitmap%, vbResBitmap)
    End If

    'Return the image
    GetButtonPicture = True
    Exit Function

LoadError:
    If boolDebug Then
'        MsgBox "Error loading bitmap: " & Err.Description
    End If
    GetButtonPicture = False
End Function


'##########################################################################
'##########################################################################
'##########################################################################


'Return a description string for this package of tools
Public Property Get Description() As String
    Description = "TextAlongCurve"
End Property

'Called to perform tool function
Public Function Run(ByVal Tool As Object) As Boolean
    On Error GoTo ErrorHandler
Dim theXTool As Tool
    Set theXTool = Tool
'    theXTool.Application.ActiveDrawing.Graphics.Unselect
    
    Set GrCon = Nothing
    If iConnectId <> -1 Then
        objApp.DisconnectEvents iConnectId
        AddLM False
        iConnectId = -1
        iActTool = -1
        theToolEvents.ToolChangePrompt Me, "", False
    Else
        theToolEvents.ToolChangePrompt Me, "", False
        iConnectId = objApp.ConnectEvents(Me, EventMask)
        iActTool = theXTool.Index
        AddLM True
        theToolEvents.ToolChangePrompt Me, "Select a graphic", False
    End If

    
    Exit Function
ErrorHandler:
'    MsgBox Err.Msg
    Call Finish
End Function




'Fill arrays with information about tools in the package
'Return the number of tools in the package
Public Function GetToolInfo(CommandNames As Variant, MenuCaptions As Variant, StatusPrompts As Variant, _
    ToolTips As Variant, Enabled As Variant, WantsUpdates As Variant) As Long

    ReDim CommandNames(NUM_TOOLS)
    ReDim MenuCaptions(NUM_TOOLS, 2)
    ReDim StatusPrompts(NUM_TOOLS)
    ReDim ToolTips(NUM_TOOLS)
    ReDim Enabled(NUM_TOOLS)
    ReDim WantsUpdates(NUM_TOOLS)
    CommandNames(0) = "S&DK|&Insert|TextAlongCurve"
    MenuCaptions(0, 0) = "&TextAlongCurve"
    MenuCaptions(0, 1) = "SDK" 'toolbar name
    ToolTips(0) = "TextAlongCurve"
    Enabled(0) = True
    WantsUpdates(0) = False
    GetToolInfo = NUM_TOOLS
End Function



'Returns true if tool is correctly initialized
Public Function Initialize(ByVal Tool As Object) As Boolean
On Error GoTo ErrorHandler
    Set objApp = Tool.Application
    Set theToolEvents = objApp
    iConnectId = -1
    iActTool = -1
    Initialize = True
    Exit Function
ErrorHandler:
 '   MsgBox Err.Description
End Function

'Returns true if tool is correctly initialized
Public Function UpdateToolStatus(ByVal Tool As Object, Enabled As Boolean, Checked As Boolean) As Boolean
    Enabled = True 'Could do a test here to determine whether to disable the button/menu item
    If iConnectId = -1 Then
        Checked = False  'Could do a test here to determine whether to check the button/menu item
    Else
        Checked = True
    End If
    UpdateToolStatus = True
End Function


Public Function RunTool(WhichTool As Tool)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function



Public Function BeforeExit(WhichApplication As Application, Cancel As Boolean)
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish

End Function
Public Function DrawingNew(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    
    Call Finish
End Function
Public Function DrawingOpen(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingActivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingDeactivate(WhichDrawing As Drawing)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeClose(WhichDrawing As Drawing, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    AddLM False
    Call Finish
End Function
Public Function DrawingBeforeSave(WhichDrawing As Drawing, SaveAs As Boolean, Cancel As Boolean)
    On Error Resume Next
    theToolEvents.ToolChangePrompt Me, "", False  '????
    objApp.DisconnectEvents iConnectId       '????
    iConnectId = -1       '????
    Call Finish
End Function



Public Function MouseDown(WhichDrawing As Drawing, WhichView As View, WhichWindow As Window, Button As ImsiMouseButton, Shift As Long, x As Long, y As Long, Cancel As Boolean)
Dim xView#, yView#
On Error GoTo ErrorHandler
    Set Drs = objApp.Drawings
    Set ActDr = WhichDrawing
    Set Grs = ActDr.Graphics
    Set Vis = ActDr.Views
    Set Vi = WhichView
    hDr = TCWDrawingActive
Dim Res As Integer
    Vi.ScreenToView x, y, xView, yView
    
    If Button = imsiLeftButton Then
        Cancel = True
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        Res = SelectCurve(xView, yView)
        If Res = 0 Or Res = 1 Then
            If GrCon Is Nothing Then
                Beep
                MsgBox "The object is not selected. Please,try to select it again.", , "Text Along Curve"
            Else
                Beep
                MsgBox "The selection object is not valid for this operation.", , "Text Along Curve"
                GrCon.Properties("Selected") = False
                GrCon.Draw
            End If
            theToolEvents.ToolChangePrompt Me, "", False
            theToolEvents.ToolChangePrompt Me, "Select a graphic", False
            Exit Function
        End If
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        Cancel = True
        Call Finish
    Else
        Cancel = False
    End If
'    Call Finish
    Exit Function
ErrorHandler:
    If iConnectId <> -1 Then
        theToolEvents.ToolChangePrompt Me, "", False
        objApp.DisconnectEvents iConnectId
        iConnectId = -1
        AddLM False
    End If
    Call Finish
 '   MsgBox Err.Description
End Function

Public Function Cancel(DoItPlease As Boolean, CanCancel As Boolean)
    If (DoItPlease) Then
        If iConnectId <> -1 Then
            theToolEvents.ToolChangePrompt Me, "", False
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
        End If
                
        theToolEvents.ToolChangePrompt Me, "", False
        Call Finish
    End If

    CanCancel = True
End Function

Public Function UpdateUndo(AllowsUndo As Boolean)
    AllowsUndo = False
End Function

Private Function AddActToolLM(iTool As Long, bAdd As Boolean)
'    AddLM bAdd
End Function
Private Sub Class_Terminate()
    If (Not theToolEvents Is Nothing) Then
        Set theToolEvents = Nothing
    End If
    If (Not objApp Is Nothing) Then
        Set objApp = Nothing
    End If
    
End Sub



Private Function AddLM(bAdd As Boolean)
Dim Captions(0 To 0) As String
Dim Prompts(0 To 0) As String
Dim Enabled(0 To 0) As Boolean
Dim Checked(0 To 0) As Boolean

Dim varCaptions As Variant
Dim varPrompts As Variant
Dim varEnabled As Variant
Dim varChecked As Variant

    If (bAdd) Then
        Captions(0) = "Finish TextAlongCurve"
        Prompts(0) = "Finish TextAlongCurve"
        Enabled(0) = True
        Checked(0) = True
        varCaptions = Captions
        varPrompts = Prompts
        varEnabled = Enabled
        varChecked = Checked
        
        theToolEvents.ToolChangeCommands Me, 1, varCaptions, varPrompts, varEnabled, varChecked, True
    Else
        theToolEvents.ToolChangeCommands Me, 0, , , , , False
    End If
End Function

Public Function DoLMCommand(CmdInd As Long)
'MsgBox ("CmdInd=" & CStr(CmdInd))
   If CmdInd = 0 Then
         If iConnectId <> -1 Then
            objApp.DisconnectEvents iConnectId
            iConnectId = -1
            AddLM False
        End If
        theToolEvents.ToolChangePrompt Me, "", False
      
        Call Finish
'        Set objApp = Nothing
        
    End If

End Function
Private Sub Finish()
    Set GrCon = Nothing
    Set Grs = Nothing
    Set Vi = Nothing
    Set Vis = Nothing
    Set ActDr = Nothing
    Set Drs = Nothing
 '   Set objApp = Nothing
End Sub




'########################################################################
'########################################################################
'########################################################################
' Select Curve at Mouse click

Private Function SelectCurve(xCl As Double, yCl As Double) As Integer
On Error GoTo ErrorHandler
    Set GrCon = Nothing

Dim PicRes As PickResult
Dim PicCount As Long
    ActDr.Application.SnapModes = 256 ' Nearest to graphic
    Set PicRes = Vi.PickPoint(xCl, yCl)
    PicCount = PicRes.Count
    
    If PicCount = 0 Then
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = 0 ' There are no objects in pick point
        Set PicRes = Nothing
        Exit Function
    End If
    
    Set GrCon = PicRes(0).Graphic
    GrCon.Properties("Selected") = True
    GrCon.Draw
    
Dim GrConType$, GrConID As Long
    GrConType = GrCon.Type
    If GrConType = "GRAPHIC" And GrCon.Graphics.Count > 0 Then
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = 1 ' Clicked graphic can't take part in operation
        Set PicRes = Nothing
        Exit Function
    End If
    If GrConType = "GRAPHIC" And ActDr.Properties("TileMode") = 1 Then
Dim Thick1#
        Thick1 = -1000000#
        On Error Resume Next
        Thick1 = GrCon.Properties("Thickness")
        If Thick1 = -1000000 Then ' For 3D-Polyline
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = 1 ' Clicked graphic can't take part in operation
            Set PicRes = Nothing
            Exit Function
        End If
    End If
    If GrConType = "TCW50Polyline" Then
'MsgBox (GrCon.Graphics(0).Name)
        If GrCon.Graphics(0).Name = "ChildWithWidth" Or GrCon.Graphics(0).Name = "Line_Width_Cosmetic" Then
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = 1 ' Clicked graphic can't take part in operation
            Set PicRes = Nothing
            Exit Function
        End If
    End If
    
    If GrConType = "GRAPHIC" Or GrConType = "CIRCLE" Or GrConType = "ARC" Or GrConType = "TCW30CURVE" Or GrConType = "TCW50Polyline" Then
        GrConID = GrCon.ID
    Else
        ActDr.Application.SnapModes = 1 ' Nearest to graphic
        SelectCurve = 1  ' Clicked graphic can't take part in operation
        Set PicRes = Nothing
        Exit Function
    End If
' ######################################################
Dim GrTem As Graphic
    Set GrTem = Grs.Add(11)
    GrTem.Vertices.Add 0, 0, 0
    GrTem.Vertices.Add 1, 0, 0, False
    GrTem.Draw
    
    
Dim GrText As Graphic
    Set GrText = Grs.Add(, "TextAlong.Curve")
'###############################################################
Dim MyText$
Dim Location%
Dim TextLocation$
Dim SurvCoord%
Dim HeightText#
Dim Thick#
Dim InvertSym%
Dim TextOffset#

Dim StyleText%
Dim ModeText%
Dim FontText$
    Load frmToolTextAlong
        With GrText.Properties
            MyText = .Item("MyText")
            Location = .Item("TextLocation")
            HeightText = .Item("HeightText")
            Thick = .Item("Thick")
            InvertSym = .Item("InvertSym")
            TextOffset = .Item("TextOffset")
            StyleText = .Item("StyleText")
            ModeText = .Item("ModeText")
            FontText = .Item("FontText")
        End With
        
        With frmToolTextAlong
            .MyText.Text = MyText
            
            If Location = 1 Then .Location.Text = "Above"
            If Location = 0 Then .Location.Text = "Middle"
            If Location = -1 Then .Location.Text = "Bottom"
            
            .HeightText.Text = CStr(HeightText)
            .Thick.Text = CStr(Thick)
            .InvertSym.Value = InvertSym
            .TextOffset.Text = CStr(TextOffset)
            
            If StyleText = 0 Then .StyleText.Text = "Regular"
            If StyleText = 1 Then .StyleText.Text = "Italic"
            If StyleText = 2 Then .StyleText.Text = "Bold"
            If StyleText = 3 Then .StyleText.Text = "Bold Italic"
        
            If ModeText = 1 Then .ModeText.Text = "Standard"
            If ModeText = 2 Then .ModeText.Text = "Scalable"
            If ModeText = 3 Then .ModeText.Text = "Flexible"
            
            .FontText.Text = FontText
        
        End With
        
        frmToolTextAlong.Show 1
        If FormCancel = True Then
            GrCon.Properties("Selected") = False
            GrCon.Draw
            ActDr.Application.SnapModes = 1 ' Nearest to graphic
            SelectCurve = 2 ' Form was canceled
            GrText.Deleted = True
            GrTem.Deleted = True
            Set GrTem = Nothing
            Set GrCon = Nothing
           Set GrText = Nothing
            Set PicRes = Nothing
            Exit Function
        End If
        
            With frmToolTextAlong
                MyText = .MyText.Text
                GrText.Properties("MyText") = MyText
                
                TextLocation = .Location.Text
                If TextLocation = "Above" Then Location = 1
                If TextLocation = "Middle" Then Location = 0
                If TextLocation = "Bottom" Then Location = -1
                GrText.Properties("TextLocation") = Location
                                
                HeightText = CDbl(.HeightText.Text)
                GrText.Properties("HeightText") = HeightText
            
                Thick = CDbl(.Thick.Text)
                GrText.Properties("Thick") = Thick
            
                InvertSym = CInt(.InvertSym.Value)
                GrText.Properties("InvertSym") = InvertSym
                
                TextOffset = CDbl(.TextOffset.Text)
                GrText.Properties("TextOffset") = TextOffset
                
                If .StyleText.Text = "Regular" Then GrText.Properties("StyleText") = 0
                If .StyleText.Text = "Italic" Then GrText.Properties("StyleText") = 1
                If .StyleText.Text = "Bold" Then GrText.Properties("StyleText") = 2
                If .StyleText.Text = "Bold Italic" Then GrText.Properties("StyleText") = 3
                
                If .ModeText.Text = "Standard" Then GrText.Properties("ModeText") = 1
                If .ModeText.Text = "Scalable" Then GrText.Properties("ModeText") = 2
                If .ModeText.Text = "Flexible" Then GrText.Properties("ModeText") = 3
                
                GrText.Properties("FontText") = .FontText.Text
            End With
   
'###############################################################


Dim hGrText As Long
    hGrText = TCWGraphicAt(hDr, GrText.Index)
    TCWUndoRecordStart hDr, "Add TextAlongCurve"
    TCWUndoRecordAddGraphic hDr, hGrText
    TCWUndoRecordEnd hDr
    
Dim hGrCon As Long, hMat As Long
    hGrCon = TCWGraphicAt(hDr, GrCon.Index)
    hMat = GraphicGetMatrix(hGrCon)
    GraphicSetMatrix hGrText, hMat
    
Dim xPic#, yPic#
Dim Ver As Vertex
        Set Ver = PicRes(0).ClosestVertex
        xPic = Ver.x
        yPic = Ver.y
        
    GrText.Properties("GrConID") = GrConID
    GrText.Properties("GrConType") = GrConType
    GrText.Properties("PenColor") = GrCon.Properties("PenColor")
    GrText.Update
    
Dim TSets As TieSets
Dim TSet As TieSet
    Set TSet = Nothing
    On Error Resume Next
    Set TSets = ActDr.TieSets
    On Error Resume Next
    Set TSet = TSets.TieSet(GrCon.ID, GrText.ID)
    
    If TSet Is Nothing Then
        TSets.Add "Curve.TextTie", GrCon, GrText, 0, 0
    End If
    

    
    With GrText.Vertices
        .Item(0).x = xPic
        .Item(0).y = yPic
    End With
   GrText.Update
    
'###################################################################
'###################################################################
' Write New data into Tie data
        Call UpdateTie1(GrCon, GrText, TSets)
    
    
'###################################################################
'###################################################################
    
    
    ActDr.Application.SnapModes = 1 ' Nearest to graphic
    GrTem.Deleted = True
    GrCon.Properties("Selected") = False
    GrCon.Draw
    
    GrText.Draw
    Set GrText = Nothing
    Set GrTem = Nothing
    Set GrCon = Nothing
    Set PicRes = Nothing
    Set TSet = Nothing
    Set TSets = Nothing
    SelectCurve = True
    
    Exit Function
ErrorHandler:
    Set GrCon = Nothing
    Set GrText = Nothing
    Set PicRes = Nothing
    Set TSet = Nothing
    Set TSets = Nothing
    SelectCurve = False
    ActDr.Application.SnapModes = 1 ' Nearest to graphic

End Function



' Update Tie after moving center vertex of Text
Private Sub UpdateTie1(GrCon As Graphic, GrText As Graphic, TSets As TieSets)
Dim idSbj As Long, idSbd As Long
    idSbj = GrCon.ID
    idSbd = GrText.ID
'###############################################################
Dim TSet As TieSet
    Set TSet = TSets.TieSet(idSbj, idSbd)
Dim TSet1 As TieSet
    Set TSet1 = TSets.TieSet(idSbd, idSbj)
Dim varData As Variant
Dim Tie As Tie
    Set Tie = TSet(0)
    varData = Tie.Data
Dim varData1 As Variant
Dim Tie1 As Tie
    Set Tie1 = TSet1(0)
    varData1 = Tie1.Data

Dim xLoc0Text#, yLoc0Text#, AnglePrev#, ConVertex As Long, xLoc0RelText#
Dim fiMidPrev#, xcPrev#, ycPrev#
Dim LFullPrev#, x0Prev#, y0Prev#, x1Prev#, y1Prev#, L0RelPrev#, L1RelPrev#, L2RelPrev#
    
    ConVertex = varData(0).idVertPoly
    AnglePrev = varData(0).AnglePrev
    xLoc0RelText = varData(0).xLocRelPrev
    
    fiMidPrev = varData(0).fiMidPrev
    xcPrev = varData(0).xcPrev
    ycPrev = varData(0).ycPrev
    
    LFullPrev = varData(0).LFullPrev     ' for Curve or TCW50Polyline
    x0Prev = varData(0).x0Prev     ' for Curve or TCW50Polyline
    y0Prev = varData(0).y0Prev     ' for Curve or TCW50Polyline
    x1Prev = varData(0).x1Prev     ' for Curve or TCW50Polyline
    y1Prev = varData(0).y1Prev     ' for Curve or TCW50Polyline
    L0RelPrev = varData(0).L0RelPrev     ' for Curve or TCW50Polyline
    L1RelPrev = varData(0).L1RelPrev    ' for Curve or TCW50Polyline
    L2RelPrev = varData(0).L2RelPrev    ' for Curve or TCW50Polyline
'MsgBox ("LFullPrev=" & CStr(LFullPrev) & "  L0RelPrev=" & CStr(L0RelPrev))
'#################################################################
Dim GrConType$
    GrConType = GrCon.Type
        If GrConType = "GRAPHIC" Or GrConType = "CIRCLE" Or GrConType = "ARC" Or GrConType = "TCW30CURVE" Or GrConType = "TCW50Polyline" Then
Dim GrCosm As Graphic
            If GrConType = "TCW30CURVE" Then
                Set GrCosm = GrCon.Graphics(1)
            End If
            If GrConType = "TCW50Polyline" Then
                Set GrCosm = GrCon.Graphics(0)
            End If
            If (GrConType = "CIRCLE" And GrCon.Unbounded = False) Or GrConType = "ARC" Then
                Set GrCosm = GrCon.Duplicate
                If GrCon.Drawing.Properties("TileMode") = 1 Then
                    GrCosm.Properties("Thickness") = 0
                    GrCosm.Update
                End If
                GrCosm.Properties("BrushStyle") = ""
                GrCosm.Update
                GrCon.Drawing.Graphics.Remove GrCosm.Index
                Set GrCosm = GrCosm.Explode(0)
            End If
        
Dim nVCosm As Long, i As Long
            If GrCon.Unbounded = True And GrConType = "CIRCLE" Then
                nVCosm = 50
            Else
                If GrConType = "GRAPHIC" Then
                    nVCosm = GrCon.Vertices.Count
                Else
                    nVCosm = GrCosm.Vertices.Count
                End If
            End If
Dim CurInfo As CosmInfo
ReDim CurInfo.dL(nVCosm + 5)
ReDim CurInfo.lCur(nVCosm + 5)
ReDim CurInfo.xVer(nVCosm + 5)
ReDim CurInfo.yVer(nVCosm + 5)
ReDim CurInfo.Bet(nVCosm + 5)
            If GrCon.Unbounded = True And GrConType = "CIRCLE" Then
                Call FormConCircStruct(GrCon, CurInfo, LFullPrev)
            Else
                If GrConType = "GRAPHIC" Then
                    Call FormCosmStruct(GrCon, CurInfo, LFullPrev)
                Else
                    Call FormCosmStruct(GrCosm, CurInfo, LFullPrev)
                End If
                
                If GrConType = "CIRCLE" Or GrConType = "ARC" Then
                    GrCosm.Deleted = True
                End If
            End If
            
            If GrConType = "CIRCLE" Then
                With GrCon.Vertices
                    x0Prev = .Item(0).x
                    y0Prev = .Item(0).y
                    x1Prev = .Item(1).x
                    y1Prev = .Item(1).y
                End With
            Else
                x0Prev = CurInfo.xVer(0)
                y0Prev = CurInfo.yVer(0)
                x1Prev = CurInfo.xVer(1)
                y1Prev = CurInfo.yVer(1)
            End If
Dim x0#, y0#, x1#, y1#, x2#, y2#
        ' Define parameters for TextAlongCurve
            With GrText.Vertices
                x0 = .Item(0).x
                y0 = .Item(0).y
                x1 = .Item(1).x
                y1 = .Item(1).y
                x2 = .Item(2).x
                y2 = .Item(2).y
            End With
Dim L0#, L1#, L2#
Dim iMin As Long, xLocMin#
            Call NumSegmByXY(CurInfo, x0, y0, iMin, L0, xLocMin)
            Call NumSegmByXY(CurInfo, x1, y1, iMin, L1, xLocMin)
            Call NumSegmByXY(CurInfo, x2, y2, iMin, L2, xLocMin)
            L0RelPrev = L0 / LFullPrev
            L1RelPrev = L1 / LFullPrev
            L2RelPrev = L2 / LFullPrev
'MsgBox ("Edit Text L0Rel=" & CStr(L0RelPrev) & "  L1Rel=" & CStr(L1RelPrev) & "  L2Rel=" & CStr(L2RelPrev))
            
            varData(0).L0RelPrev = L0RelPrev
            varData(0).L1RelPrev = L1RelPrev
            varData(0).L2RelPrev = L2RelPrev
            Tie.Data = varData(0)
            varData1(0).L0RelPrev = L0RelPrev
            varData1(0).L1RelPrev = L1RelPrev
            varData1(0).L2RelPrev = L2RelPrev
            Tie1.Data = varData1(0)
        End If

        Set Tie = Nothing
        Set Tie1 = Nothing
        Set TSet = Nothing
        Set TSet1 = Nothing
        Set GrCosm = Nothing

End Sub

' Write the Data about CONSTRUCTION CIRCLE into Structure for Graphic and Curve and TCW50olyline

Private Sub FormConCircStruct(GrCirc As Graphic, CurInfo As CosmInfo, LFull As Double)

Dim xi#, yi#, xi1#, yi1#, L#, dL#, sina#, cosa#, Bet#
Dim xc#, yc#, x1#, y1#
    With GrCirc.Vertices
        xc = .Item(0).x
        yc = .Item(0).y
        x1 = .Item(1).x
        y1 = .Item(1).y
    End With
Dim nV As Long, i As Long
    nV = 41
Dim R#, dfi#
    R = Sqr((x1 - xc) * (x1 - xc) + (y1 - yc) * (y1 - yc))
    LFull = 2 * Pi * R
    dfi = 2 * Pi / (nV - 1)

    CurInfo.nV = nV
    L = 0
    CurInfo.lCur(0) = L
    For i = 0 To nV - 2
        xi = xc + R * Cos(dfi * i)
        yi = yc + R * Sin(dfi * i)
        xi1 = xc + R * Cos(dfi * (i + 1))
        yi1 = yc + R * Sin(dfi * (i + 1))
        dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
        sina = (yi1 - yi) / dL
        cosa = (xi1 - xi) / dL
        Bet = Angle(sina, cosa)
        L = L + dL
        CurInfo.xVer(i) = xi
        CurInfo.yVer(i) = yi
        CurInfo.lCur(i + 1) = L
        CurInfo.dL(i) = dL
        CurInfo.Bet(i) = Bet
    Next i
    CurInfo.xVer(nV - 1) = xi1
    CurInfo.yVer(nV - 1) = yi1
    

End Sub

'#######################################################################
'#######################################################################
'#######################################################################
'#######################################################################


' Write the Data about cosmetic into Structure for Curve and TCW50olyline
Private Sub FormCosmStruct(Gr As Graphic, CurInfo As CosmInfo, LFull As Double)
Dim CurveClosed As Boolean
        If Gr.Closed = True Then
            CurveClosed = True
        Else
            CurveClosed = False
        End If
Dim nV As Long, i As Long, j As Long
        nV = Gr.Vertices.Count
Dim L#, xi#, yi#, xi1#, yi1#, dL#, sina#, cosa#, Bet#
        If CurveClosed = True Then
            CurInfo.nV = nV
            L = 0
            CurInfo.lCur(0) = L
            With Gr.Vertices
                For i = 0 To nV - 2
                    xi = .Item(i).x
                    yi = .Item(i).y
                    xi1 = .Item(i + 1).x
                    yi1 = .Item(i + 1).y
                    dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                    If dL < Eps Then
                        dL = 0
                        Bet = 0
                    Else
                        sina = (yi1 - yi) / dL
                        cosa = (xi1 - xi) / dL
                        Bet = Angle(sina, cosa)
                    End If
                    L = L + dL
                    CurInfo.xVer(i) = xi
                    CurInfo.yVer(i) = yi
                    CurInfo.lCur(i + 1) = L
                    CurInfo.dL(i) = dL
                    CurInfo.Bet(i) = Bet
                Next i
                CurInfo.xVer(nV - 1) = xi1
                CurInfo.yVer(nV - 1) = yi1
            End With
        Else
            CurInfo.nV = nV + 2
Dim k As Long
            k = 0
Dim xPrev#, yPrev#, xLast#, yLast#, LAdd#
            LAdd = 10
            L = 0
            
            CurInfo.lCur(0) = L
            With Gr.Vertices
                'First added segment
                xi = .Item(0).x
                yi = .Item(0).y
                xi1 = .Item(1).x
                yi1 = .Item(1).y
                dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                If dL < Eps Then
                    For j = 1 To nV - 1
                        xi1 = .Item(j).x
                        yi1 = .Item(j).y
                        dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                        If dL > Eps Then Exit For
                    Next j
                End If
                xPrev = xi1 + (xi - xi1) * (LAdd + dL) / dL
                yPrev = yi1 + (yi - yi1) * (LAdd + dL) / dL
                xi1 = xi
                yi1 = yi
                xi = xPrev
                yi = yPrev
                dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                sina = (yi1 - yi) / dL
                cosa = (xi1 - xi) / dL
                Bet = Angle(sina, cosa)
                L = L + dL
                CurInfo.xVer(k) = xi
                CurInfo.yVer(k) = yi
                CurInfo.lCur(k + 1) = L
                CurInfo.dL(k) = dL
                CurInfo.Bet(k) = Bet
                k = k + 1
                
                 'Base cosmetic segments
                For i = 0 To nV - 2
                    xi = .Item(i).x
                    yi = .Item(i).y
                    xi1 = .Item(i + 1).x
                    yi1 = .Item(i + 1).y
                    dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                    If dL < Eps Then
                        dL = 0
                        Bet = 0
                    Else
                        sina = (yi1 - yi) / dL
                        cosa = (xi1 - xi) / dL
                        Bet = Angle(sina, cosa)
                    End If
                    L = L + dL
                    CurInfo.xVer(k) = xi
                    CurInfo.yVer(k) = yi
                    CurInfo.lCur(k + 1) = L
                    CurInfo.dL(k) = dL
                    CurInfo.Bet(k) = Bet
                    k = k + 1
                Next i
                'Last added segment
                xi = .Item(nV - 2).x
                yi = .Item(nV - 2).y
                xi1 = .Item(nV - 1).x
                yi1 = .Item(nV - 1).y
                dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                If dL < Eps Then
                    For j = nV - 3 To 0 Step -1
                        xi = .Item(j).x
                        yi = .Item(j).y
                        dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                        If dL > Eps Then Exit For
                    Next j
                End If
                xLast = xi + (xi1 - xi) * (LAdd + dL) / dL
                yLast = yi + (yi1 - yi) * (LAdd + dL) / dL
                xi = xi1
                yi = yi1
                xi1 = xLast
                yi1 = yLast
                dL = Sqr((xi1 - xi) * (xi1 - xi) + (yi1 - yi) * (yi1 - yi))
                sina = (yi1 - yi) / dL
                cosa = (xi1 - xi) / dL
                Bet = Angle(sina, cosa)
                L = L + dL
                CurInfo.xVer(k) = xi
                CurInfo.yVer(k) = yi
                CurInfo.lCur(k + 1) = L
                CurInfo.dL(k) = dL
                CurInfo.Bet(k) = Bet
                k = k + 1
                CurInfo.xVer(k) = xi1
                CurInfo.yVer(k) = yi1
            End With
            ' Edit Content of CurInfo Structure for nonclosed curve
            Call EditCurInfoNonClosed(CurInfo, L)
        End If
        LFull = L
        
End Sub


' Edit Content of CurInfo Structure for nonclosed curve

Private Sub EditCurInfoNonClosed(CurInfo As CosmInfo, L As Double)
Dim nV As Long, i As Long
Dim LClear#
    LClear = L - 20
    nV = CurInfo.nV
Dim xi#, yi#, xi1#, yi1#
    ' First line segment
    xi = CurInfo.xVer(1)
    yi = CurInfo.yVer(1)
    xi1 = CurInfo.xVer(0)
    yi1 = CurInfo.yVer(0)
    
    xi1 = xi + (xi1 - xi) * LClear / 10
    yi1 = yi + (yi1 - yi) * LClear / 10
    CurInfo.xVer(0) = xi1
    CurInfo.yVer(0) = yi1
    CurInfo.lCur(1) = LClear
    CurInfo.dL(0) = LClear
    
    ' Middle segments
Dim dL#, LTem#
    LTem = LClear
    For i = 2 To nV - 2
        dL = CurInfo.dL(i - 1)
        LTem = LTem + dL
        CurInfo.lCur(i) = LTem
    Next i
    
    ' End line segment
    xi = CurInfo.xVer(nV - 2)
    yi = CurInfo.yVer(nV - 2)
    xi1 = CurInfo.xVer(nV - 1)
    yi1 = CurInfo.yVer(nV - 1)
    
    xi1 = xi + (xi1 - xi) * LClear / 10
    yi1 = yi + (yi1 - yi) * LClear / 10
    CurInfo.xVer(nV - 1) = xi1
    CurInfo.yVer(nV - 1) = yi1
    CurInfo.lCur(nV - 1) = LTem + LClear
    CurInfo.dL(nV - 2) = LClear
    
    L = LTem + LClear
End Sub




' define the number of segment by X-Y coordinate of the point
' Return values iMin - Number of segment,
'                Li -Lenght from begining Curve
'                xlocMin - local coordinate on segment

Private Sub NumSegmByXY(CurInfo As CosmInfo, x As Double, y As Double, iMin As Long, Li As Double, xLocMin As Double)
Dim nV As Long, i As Long
Dim xi#, yi#, xi1#, yi1#, Bet#, sina#, cosa#, dL#
Dim xLoc#, yLoc#
Dim yLocMin#

    yLocMin = 1000000
    nV = CurInfo.nV
    For i = 0 To nV - 2
        xi = CurInfo.xVer(i)
        yi = CurInfo.yVer(i)
        xi1 = CurInfo.xVer(i + 1)
        yi1 = CurInfo.yVer(i + 1)
        dL = CurInfo.dL(i)
        Bet = CurInfo.Bet(i)
        sina = Sin(Bet)
        cosa = Cos(Bet)
        yLoc = (y - yi) * cosa - (x - xi) * sina
        xLoc = (y - yi) * sina + (x - xi) * cosa
'MsgBox ("i=" & CStr(i) & "  xi=" & CStr(xi) & " yi=" & CStr(yi) & "  xi1=" & CStr(xi1) & " yi1=" & CStr(yi1) & " dL=" & CStr(dL) & " Bet=" & CStr(Bet * 180 / Pi))
'MsgBox ("xLoc=" & CStr(xLoc) & " yLoc=" & CStr(yLoc))
        If Abs(yLoc) < yLocMin And xLoc > -Eps And xLoc < dL + Eps Then
            yLocMin = Abs(yLoc)
            iMin = i
'            If iMin = 0 Then
'                Li = xLoc
'            Else
                Li = CurInfo.lCur(i) + xLoc
'            End If
            xLocMin = xLoc
        End If
    Next i

    
End Sub

Private Function Angle(sinb As Double, cosb As Double) As Double

        If Abs(cosb) < 0.0001 Then
            If sinb > 0 Then
                Angle = Pi / 2
            Else
                Angle = 3 * Pi / 2
            End If
        Else
            If sinb >= 0 And cosb > 0 Then Angle = Atn(sinb / cosb)
            If sinb >= 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb < 0 Then Angle = Pi + Atn(sinb / cosb)
            If sinb < 0 And cosb > 0 Then Angle = 2 * Pi + Atn(sinb / cosb)
        End If
End Function

